'From Squeak 2.5 of August 6, 1999 on 10 September 1999 at 4:23:30 pm'!
"Change Set:		cmdShiftClick-sw
Date:			10 September 1999
Author:			Scott Wallace

Rescinds the cmd-shift-mouse feature (that had always grabbed the topmost direct submorph of the World,) making cmd-shift-mouse now an exact synonym for cmd-mouse.  Thus, in particular, halos come up as usual on cmd-click whether or not the shift key is down.  Ref: Naala/John/Scott correspondence of 10 Sept 99"!


!HandMorph methodsFor: 'special gestures' stamp: 'sw 9/10/1999 16:19'!
specialGesture: evt
	"Special gestures (cmd-mouse on the Macintosh) allow a mouse-sensitive morph to be moved or bring up a halo for the morph."
	"Summary:
		Cmd-click			pop up halo
		Cmd-drag			reposition morph"

	Preferences cmdGesturesEnabled ifFalse: [^ self].

	self newMouseFocus: nil.

	"if carrying morphs, just drop them"
	self hasSubmorphs ifTrue: [^ self dropMorphsEvent: evt].

	targetOffset _ menuTargetOffset _ self position.
	argument _ self argumentOrNil.
	self popUpHaloFromClick: evt
! !


