'From Squeak2.7alpha of 25 October 1999 [latest update: #1606] on 10 November 1999 at 8:54:33 pm'!
"Change Set:		ENHObjectExplorer
Date:			11 November 1999
Author:			Chris Norton

This snippit adds 'objects pointing to this value', 'browse full', 'browse class' and 'browse hierarchy' options to object explorer's hierarchical morph menu.

Please direct your questions and/or comments to: chrisn@kronos.com"!


!ObjectExplorer methodsFor: 'as yet unclassified' stamp: 'ccn 11/10/1999 20:48'!
genericMenu: aMenu

	| insideObject menu |
	currentSelection ifNil: [
		menu _ aMenu.
		menu add: '*nothing selected*' target: self selector: #yourself.
	] ifNotNil: [
		menu _ DumberMenuMorph new defaultTarget: self.
		insideObject _ currentSelection withoutListWrapper.
		menu 
			add: 'explore' target: insideObject  selector: #explore;
			add: 'inspect' target: insideObject  selector: #inspect;
			add: 'basic inspect' target: insideObject  selector: #basicInspect;
			add: 'smart inspect' target: insideObject  selector: #smartInspect;
			addLine;
			add: 'objects pointing to this value' target: Smalltalk  selector:  #browseAllObjectReferencesTo:except:ifNone:  argumentList: (Array with: insideObject with: #() with: nil);
			addLine;
			add: 'browse full' target: Browser  selector: #fullOnClass:  argument: insideObject class;
			add: 'browse class' target: insideObject class  selector: #browse;
			add: 'browse hierarchy' target: Utilities  selector:  #spawnHierarchyForClass:selector: argumentList: (Array with: insideObject class with: nil).
	].
	^menu! !

