'From Squeak2.6 of 11 October 1999 [latest update: #1634] on 23 November 1999 at 11:56:35 am'!
"Change Set:		nextPrevCat-sw
Date:			23 November 1999
Author:			Scott Wallace

In a category pane of a Viewer, if the user hits the next or prev arrow, the next or previous category that is *not already showing* is installed.  This is in response to a recommendation from Kim Rose and Wendy Carmical, among others."!


!CategoryViewer methodsFor: 'categories' stamp: 'sw 11/18/1999 16:07'!
nextCategory
	| aList anIndex newIndex already aChoice |
	aList _ scriptedPlayer categories.
	already _ self outerViewer ifNil: [#()] ifNotNil: [self outerViewer categoriesCurrentlyShowing].
	anIndex _ aList indexOf: self currentCategory ifAbsent: [0].
	newIndex _ anIndex = aList size
		ifTrue:		[1]
		ifFalse:		[anIndex + 1].
	[already includes: (aChoice _ aList at: newIndex)] whileTrue:
		[newIndex _ (newIndex \\ aList size) + 1].
	self categoryChoice: aChoice! !

!CategoryViewer methodsFor: 'categories' stamp: 'sw 11/18/1999 16:11'!
previousCategory
	| aList anIndex newIndex already aChoice |
	aList _ scriptedPlayer categories.
	already _ self outerViewer ifNil: [#()] ifNotNil: [self outerViewer categoriesCurrentlyShowing].
	anIndex _ aList indexOf: self currentCategory ifAbsent: [aList size + 1].
	newIndex _ anIndex = 1
		ifTrue:		[aList size]
		ifFalse:		[anIndex - 1].
	[already includes: (aChoice _ aList at: newIndex)] whileTrue:
		[newIndex _ newIndex = 1 ifTrue: [aList size] ifFalse: [newIndex - 1]].

	self categoryChoice: aChoice! !

!CategoryViewer methodsFor: 'support' stamp: 'sw 11/18/1999 16:04'!
outerViewer
	"Answer the StandardViewer or equivalent that contains this object"
	^ self ownerThatIsA: Viewer! !


!StandardViewer methodsFor: 'as yet unclassified' stamp: 'sw 11/18/1999 16:00'!
categoriesCurrentlyShowing
	^ self categoryMorphs collect: [:m | m currentCategory]! !


