'From Squeak2.6 of 11 October 1999 [latest update: #1658] on 28 November 1999 at 9:00:17 am'!
"Change Set:		FileListBugFixes
Date:			28 November 1999
Author:			Steve Elkins

Parameterizes 2 very similar FileList methods, #addNewDirectory and #addNewFile, as well as removing the same bug from each, that pushing the cancel button in the FillInTheBlank dialog gave a walkback."!


!FileList methodsFor: 'file list menu' stamp: 'sge 11/28/1999 09:03'!
addNew: aString byEvaluating: aBlock
	"A parameterization of earlier versions of #addNewDirectory and
	#addNewFile.  Fixes the bug in each that pushing the cancel button
	in the FillInTheBlank dialog gave a walkback."

	| response newName index ending |
	self okToChange ifFalse: [^ self].
	(response _ FillInTheBlank request: 'New ',aString,' Name?'
 					initialAnswer: aString,'Name')
		isEmpty ifTrue: [^ self].
	newName _ response asFileName.
	Cursor wait showWhile: [
		aBlock value: newName].
	self updateFileList.
	index _ list indexOf: newName.
	index = 0 ifTrue: [ending _ ') ',newName.
		index _ list findFirst: [:line | line endsWith: ending]].
	self fileListIndex: index.
! !

!FileList methodsFor: 'file list menu' stamp: 'sge 11/28/1999 09:04'!
addNewDirectory
	self 
		addNew: 'Directory'
		byEvaluating: [:newName | directory createDirectory: newName]
! !

!FileList methodsFor: 'file list menu' stamp: 'sge 11/28/1999 09:04'!
addNewFile
	self 
		addNew: 'File'
		byEvaluating: [:newName | (directory newFileNamed: newName) close]
! !


