'From Squeak2.6 of 11 October 1999 [latest update: #1748] on 2 January 2000 at 11:46:32 am'!
Object subclass: #RealEstateAgent
	instanceVariableNames: ''
	classVariableNames: 'ReverseStaggerOffset StaggerOffset StaggerOrigin StandardSize StandardWindowOrigins '
	poolDictionaries: ''
	category: 'System-Support'!

!Environment methodsFor: 'dictionary access' stamp: 'tk 12/13/1999 19:48'!
atOrBelow: key ifAbsent: absentBlock
	| envt value maybe onDisk envName |
	"Compatibility hack -- find things in sub environments for now.
	Adjusted to not fault on every environment."

	^ super at: key ifAbsent:
		[onDisk _ OrderedCollection new.
		self associationsDo: [:assn | 
			(assn key endsWith: 'Environment') ifTrue: [
				envName _ (assn key copyFrom: 1 to: assn key size - 11 "Environment") asSymbol.
				(envt _ super at: envName ifAbsent: [nil]) ifNotNil: [
					envt isInMemory 
						ifTrue: [((envt isKindOf: Environment) and: [envt ~~ self])
							ifTrue: [maybe _ true.
								value _ envt atOrBelow: key ifAbsent: [maybe _ false].
								maybe ifTrue: [^ value]]]
						ifFalse: [onDisk add: envName]]]].
		onDisk do: [:outName |
			(envt _ super at: outName ifAbsent: [nil]) ifNotNil: [
				((envt isKindOf: Environment) and: [envt ~~ self])
					ifTrue: [maybe _ true.
						value _ envt atOrBelow: key ifAbsent: [maybe _ false].
						maybe ifTrue: [^ value]]]].
		^ absentBlock value]! !


!FileDirectory methodsFor: 'file directory' stamp: 'tk 12/13/1999 18:55'!
sleep
	"Leave the FileList window.  Do nothing.  Disk directories do not have to be shut down."
! !


!FileList methodsFor: 'initialization' stamp: 'tk 12/17/1999 18:00'!
modelSleep
	"User has exited or collapsed the window -- close any remote connection."

	directory ifNotNil: [directory sleep]! !


!ServerDirectory methodsFor: 'do ftp' stamp: 'tk 1/2/2000 11:46'!
sleep
	"If still connected, break the connection"

	self quit! !


