'From Squeak2.7 of 5 January 2000 [latest update: #1789] on 5 February 2000 at 2:25:18 pm'!
"Change Set:		1008NoObjExplWindow-sma
Date:			5 February 2000
Author:			Stefan Matthias Aust

Class ObjectExplorerWindow can be unified with SystemWindow.
I also removed the red border to unify the look."!


!ObjectExplorer methodsFor: 'as yet unclassified' stamp: 'sma 2/5/2000 14:23'!
explorerFor: anObject
	| window listMorph |
	rootObject _ anObject.
	window _ (SystemWindow labelled: 'Explorer') model: self.
	window addMorph: (listMorph _ SimpleHierarchicalListMorph 
			on: self
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: nil)
		frame: (0@0 corner: 1@0.8).
	window addMorph: ((PluggableTextMorph on: self text: #trash accept: #trash:
				readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
					askBeforeDiscardingEdits: false)
		frame: (0@0.8 corner: 1@1).
	listMorph autoDeselect: false.
     ^ window! !


!SystemWindow methodsFor: 'geometry' stamp: 'sma 2/5/2000 14:09'!
panelRect
	"Answer the area below the title bar which is devoted to panes."

	^ self innerBounds insetBy: (0 @ self labelHeight corner: 0 @ 0)! !


Smalltalk removeClassNamed: #ObjectExplorerWindow!
