'From Squeak2.8alpha of 13 January 2000 [latest update: #1857] on 15 February 2000 at 10:49:02 pm'!
"Change Set:		saveProject-tkNG
Date:			14 February 2000
Author:			Ted Kaehler

Defines commands in support of menu items Save Project and Load Project forthcoming in the World menu."!


!HandMorph methodsFor: 'world menu' stamp: 'tk 2/14/2000 16:26'!
loadProject
	| stdFileMenuResult fileStream |
	"Put up a Menu and let the user choose a '.project' file to load.  Create a thumbnail and jump into the project."

	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	World ifNil: [^ self inform: 
			'Later, allow jumping from MVC to Morphic Projects.'].
	stdFileMenuResult _ ((StandardFileMenu new) pattern: '*.project'; 
		oldFileFrom: FileDirectory default ) 
			startUpWithCaption: 'Select a File:'.
	stdFileMenuResult ifNil: [^ nil].
	fileStream _ stdFileMenuResult directory oldFileNamed: stdFileMenuResult name.
	ProjectViewMorph openFromFile: fileStream.! !


!PasteUpMorph methodsFor: 'menu & halo' stamp: 'tk 2/14/2000 15:17'!
saveOnFile
	"Ask the user for a filename and save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  UniClasses will be filed out."

	| aFileName fileStream ok |
	aFileName _ ('my ', self class name) asFileName.	"do better?"
	aFileName _ FillInTheBlank request: 'File name? (".project" will be added to end)' 
			initialAnswer: aFileName.
	aFileName size == 0 ifTrue: [^ self beep].
	self allMorphsDo: [:m | m prepareToBeSaved].

	ok _ aFileName endsWith: '.project'.	"don't double them"
	ok _ ok | (aFileName endsWith: '.sp').
	ok ifFalse: [aFileName _ aFileName,'.project'].
	fileStream _ FileStream newFileNamed: aFileName.
	fileStream fileOutClass: nil andObject: self.	"Puts UniClass definitions out anyway"! !


