'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 26 February 2000 at 7:11:48 pm'!
"Change Set:		01Explain-th
Date:			2 February 2000
Author:			Torge Husfeldt

Explain in code pain was broken because doitFlag in Parser was sometimes not initialized correctly. I think I found the right place to fix it."!


!Parser methodsFor: 'expression types' stamp: 'sma 2/10/2000 23:29'!
pattern: fromDoit inContext: ctxt 
	" unarySelector | binarySelector arg | keyword arg {keyword arg} => 
	{selector, arguments, precedence}."

	| args selector |
	doitFlag _ fromDoit.
	fromDoit 
		ifTrue: 
			[ctxt == nil
				ifTrue: [^Array with: #DoIt with: #() with: 1]
				ifFalse: [^Array 
							with: #DoItIn: 
							with: (Array 
									with: (encoder encodeVariable: 'homeContext')) 
									with: 3]].
	hereType == #word 
		ifTrue: [^Array with: self advance asSymbol with: #() with: 1].
	(hereType == #binary or: [hereType == #verticalBar])
		ifTrue: 
			[selector _ self advance asSymbol.
			args _ Array with: (encoder bindArg: self argumentName).
			^Array with: selector with: args with: 2].
	hereType == #keyword
		ifTrue: 
			[selector _ WriteStream on: (String new: 32).
			args _ OrderedCollection new.
			[hereType == #keyword]
				whileTrue: 
					[selector nextPutAll: self advance.
					args addLast: (encoder bindArg: self argumentName)].
			^Array with: selector contents asSymbol with: args with: 3].
	^self expected: 'Message pattern'! !


