'From Squeak2.8alpha of 4 February 2000 [latest update: #1873] on 26 February 2000 at 8:24:21 pm'!
"Change Set:		19FillInFixes-ssa
Date:			14 February 2000
Author:			Sam S. Adams

Here's a fix for FillInTheBlank so it complies with Preference settings for
scroll bars and rounded corners."!


!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'ssa 2/14/2000 13:14'!
initialize
	super initialize.
	Preferences roundedWindowCorners ifTrue: [self useRoundedCorners].
	color _ Color white.
	borderWidth _ 2.
	self extent: 200@70.
	responseUponCancel _ ''.  "Caller can reset this to return something else, e.g. nil, upon cancel"
! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'ssa 2/14/2000 13:20'!
setQuery: queryString initialAnswer: initialAnswer answerHeight: answerHeight acceptOnCR: acceptBoolean
	response _ initialAnswer.
	done _ false.
	self removeAllMorphs.
	self extent: 200@70.
	self addQuery: queryString.
	self width: (self width max: self firstSubmorph width + (2 * borderWidth)).
	self addLine.
	textPane _ PluggableTextMorph on: self
		text: #response
		accept: #response:
		readSelection: #selectionInterval
		menu: #codePaneMenu:shifted:.
	textPane hasUnacceptedEdits: true.
	textPane acceptOnCR: acceptBoolean.
	textPane extent: self innerBounds width@answerHeight.
	textPane position: self innerBounds left@self lastSubmorph bottom.
	self addMorphBack: textPane.
	self addLine.
	self addButtonRow.
	self height: (self height max: (self lastSubmorph bottom - self top) + borderWidth).
! !


