'From Squeak2.8alpha of 4 February 2000 [latest update: #1919] on 11 March 2000 at 9:01:31 pm'!
"Change Set:		04Bezier3SegmentFix-dsm
Date:			10 March 2000
Author:			Duane Maxwell

Fixes bug in computation of number of quadratic bezier segments to
approximate a cubic bezier curve for certain straight lines crossing the y
axis."
!


!Bezier3Segment methodsFor: 'converting' stamp: 'DSM 3/10/2000 12:10'!
bezier2SegmentCount: pixelError
	"Compute the number of quadratic bezier segments needed to approximate
	this cubic with no more than a specified error"
	| a |
	a _ (start x negated @ start y negated) + (3 * via1) - (3 * via2) +
(end).
	^ (((a r / (20.0 * pixelError)) raisedTo: 0.333333) ceiling) max: 1.

! !


