'From Squeak2.8alpha of 4 February 2000 [latest update: #2005] on 22 April 2000 at 5:36:13 pm'!
"Change Set:		1033SimpleMouseBtnFix-jlb
Date:			13 April 2000
Author:			Jim Benson

Here's a fix for a small bug in the SimpleButtonMorph. The line: 'oldColor _
nil' was inserted to reset the cmd-drag flag."!


!SimpleButtonMorph methodsFor: 'events' stamp: 'sma 4/22/2000 17:29'!
mouseUp: evt
	oldColor ifNotNil:
		["if oldColor nil, it signals that mouse had not gone DOWN
		inside me, e.g. because of a cmd-drag; in this case we want
		to avoid triggering the action!!"
		self color: oldColor.
		oldColor _ nil.
		(actWhen == #buttonUp and: [self containsPoint: evt cursorPoint])
			ifTrue: [self doButtonAction]]! !

