'From Squeak2.8alpha of 13 January 2000 [latest update: #2215] on 25 May 2000 at 10:48:45 pm'!
"Change Set:		firingFix-sw
Date:			25 May 2000
Author:			Scott Wallace

Fixes the long-standing bug that has made flexed morphs that have attached players fire their players' ticking scripts twice per cycle rather once."!


!Morph methodsFor: 'stepping and presenter' stamp: 'sw 5/25/2000 22:48'!
step
	| aPlayer |
	"Do some periodic activity. Use startStepping/stopStepping to start and stop getting sent this message. The time between steps is specified by this morph's answer to the stepTime message.  The generic version dispatches control to the player, if any.  The nasty circumlocation about owner's transformation is necessitated by the flexing problem that the player remains in the properties dictionary both of the flex and the real morph.  In the current architecture, only the top renderer's pointer to the player should actually be honored for the purpose of firing."

	(aPlayer _ self player) ifNotNil: 
		[(owner notNil and: [owner isRenderer not]) ifTrue:
			[aPlayer step]]
! !

