'From Squeak2.9BJ of 22 September 2000 [latest update: #2848] on 10 October 2000 at 6:05:48 pm'!
"Change Set:		PublishingFlaps-ar
Date:			10 October 2000
Author:			Andreas Raab

Adds the preference #showFlapsWhenPublishing defining whether global flaps and the navigator should be seen when the publisher executes an #armsLengthCommand.

The default is 'false' leaving us in the illusion that we're still in the same project and prevents that we see multiple overlapping flaps or navigators."!


!Project methodsFor: 'menu messages' stamp: 'ar 10/10/2000 17:56'!
finalEnterActions
	| navigator armsLengthCmd navType |

	navType _ ProjectNavigationMorph preferredNavigator.
	armsLengthCmd _ self parameterAt: #armsLengthCmd ifAbsent: [nil].
	navigator _ world findA: navType.
	Preferences showProjectNavigator & navigator isNil ifTrue: [
		(navigator _ navType new)
			bottomLeft: world bottomLeft;
			openInWorld: world.
	].
	navigator notNil & armsLengthCmd notNil ifTrue: [
		navigator color: Color lightBlue
	].
	armsLengthCmd notNil ifTrue: [
		Preferences showFlapsWhenPublishing
			ifFalse:[self flapsSuppressed: true.
					navigator ifNotNil:[navigator visible: false]].
		armsLengthCmd openInWorld: world
	].! !

"Postscript:
"
Preferences addPreference: #showFlapsWhenPublishing category: #publishing default: false balloonHelp: 'If true, show global flaps and project navigator -- otherwise suppress both to give the illusion that we are still in the same project'!

