'From Squeak2.9alpha of 17 July 2000 [latest update: #2909] on 27 October 2000 at 10:10:05 am'!
"Change Set:		superSwikiFix
Date:			27 October 2000
Author:			Bob Arning

- small fix for cases where no project info has been entered"!


!SuperSwikiServer methodsFor: 'for real' stamp: 'RAA 10/27/2000 10:08'!
updateProjectInfoFor: aProject

	| data details projectLinks linkString |

	data _ OrderedCollection new.
	data add: 'action: updatepage'.
	data add: 'projectimage: ',aProject name,'.gif'.
	projectLinks _ Set new.
	aProject world allMorphsDo: [ :each |
		(each isKindOf: ProjectViewMorph) ifTrue: [
			projectLinks add: each safeProjectName.
		].
	].
	details _ aProject world valueOfProperty: #ProjectDetails ifAbsent: [Dictionary new].
	details at: 'projectname' ifAbsentPut: [aProject name].
	projectLinks isEmpty ifTrue: [
		details removeKey: 'projectlinks' ifAbsent: []
	] ifFalse: [
		linkString _ String streamContents: [ :strm |
			projectLinks asSortedCollection do: [ :each |
				strm nextPutAll: each
			] separatedBy: [
				strm nextPut: $.
			].
		].
		details at: 'projectlinks' put: linkString
	].
	details keysAndValuesDo: [ :k :v |
		data add: k , ': ' , v
	].
	^self sendToSwikiProjectServer: data.
! !

