'From Squeak2.9alpha of 17 July 2000 [latest update: #3236] on 8 January 2001 at 10:42:47 am'!
"Change Set:		betterQuery
Date:			8 January 2001
Author:			Bob Arning

Improvements to the SuperSwiki query
- add scrollbar to results"!


!SuperSwikiServer methodsFor: 'for real' stamp: 'RAA 1/8/2001 10:40'!
showQueryAsPVM: resultStream
	| answer gif currentRow whatToShow projectName fileName firstURL wrapper |
"SuperSwikiServer testOnlySuperSwiki queryProjectsAndShow"

	resultStream reset; nextLine.
	answer _ AlignmentMorphBob1 newColumn
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		useRoundedCorners;
		borderWidth: 0;
		borderColor: Color blue;
		color: Color paleBlue.
	currentRow _ nil.
	[resultStream atEnd] whileFalse: [
		projectName _ resultStream nextLine.
		fileName _ resultStream nextLine.
		gif _ self oldFileOrNoneNamed: projectName,'.gif'.
		gif ifNotNil: [gif _ GIFReadWriter formFromStream: gif].
		(currentRow isNil or: [currentRow fullBounds width > 600]) ifTrue: [
			currentRow _ answer addARow: {}
		].
		gif ifNil: [
			gif _ AlignmentMorph newColumn
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				borderWidth: 8;
				borderColor: Color red;
				color: Color lightRed;
				addMorph: (StringMorph contents: 'No GIF for ',projectName).
			gif fullBounds.
			gif _ gif imageForm
		].
		firstURL _ self url.
		firstURL last == $/ ifFalse: [firstURL _ firstURL, '/'].

		whatToShow _ ProjectViewMorph new
			image: (gif asFormOfDepth: Display depth);
			lastProjectThumbnail: gif;
			setProperty: #SafeProjectName toValue: projectName;
			project: (DiskProxy 
				global: #Project 
				selector: #namedUrl: 
				args: {firstURL,fileName}
			).

		currentRow addMorphBack: (
			answer inAColumn: {(answer inARow: {whatToShow})
					borderWidth: 2; borderColor: Color gray; hResizing: #shrinkWrap}
		).
	].
	currentRow ifNil: [
		answer addARow: {
			(StringMorph contents: 'No projects found for your criteria') color: Color red
		}
	].
	answer fullBounds.
	wrapper _ ScrollPane new extent: (answer width + 10) @ (answer height min: 400).
	wrapper color: Color white.
	wrapper scroller addMorph: answer.
	wrapper 
		openCenteredInWorld;
		useRoundedCorners;
		setScrollDeltas.! !

