'From Squeak2.9alpha of 12 June 2000 [latest update: #3351] on 1 February 2001 at 8:58:34 pm'!
"Change Set:		TwoWayLayout
Date:			1 February 2001
Author:			Andreas Raab

At the request of Dan I., fixes a horrendous waste in layout of new tiles during insertion.
"!


!TwoWayScrollPane methodsFor: 'layout' stamp: 'ar 2/1/2001 17:00'!
doLayoutIn: layoutBounds
	"layout has changed. update scroll deltas or whatever else"
	self valueOfProperty: #maxAutoFitSize ifPresentDo:
		[:maxFitSize |
		self fitContentsUpTo: maxFitSize.
		^super doLayoutIn: layoutBounds].
	scroller ifNotNil: [self setScrollDeltas].
	super doLayoutIn: layoutBounds.! !

TwoWayScrollPane removeSelector: #layoutChanged!

!TwoWayScrollPane reorganize!
('initialization' initialize)
('access' colorForInsets scroller wantsSlot)
('geometry' containsPoint: extent: fitContentsUpTo: leftoverScrollRange resizeScrollBar resizeScroller scrollBarFills: scrollBy: scrollIntoView:extra: setScrollDeltas totalScrollRange)
('retractable scroll bar' hideOrShowScrollBar hideOrShowScrollBar:forRange: mouseEnter: mouseLeave:)
('pane events' handlesMouseDown: handlesMouseOver: keyStroke: mouseDown: mouseMove: mouseUp: rejectsEvent:)
('scroll bar events' scrollBarMenuButtonPressed: shiftedYellowButtonActivity unshiftedYellowButtonActivity xScrollBarMenuButtonPressed: xScrollBarValue: yScrollBarMenuButtonPressed: yScrollBarValue: yellowButtonActivity:)
('menu' addCustomMenuItems:hand: getMenu: leftOrRight menuTitleSelector: retractableOrNot scrollBarOnLeft:)
('layout' doLayoutIn:)
!

