'From Squeak3.1alpha of 5 February 2001 [latest update: #3591] on 14 February 2001 at 9:35:10 am'!
"Change Set:		3499EndOfVersion3-0
Date:			14 February 2001
Author:			Dan Ingalls

This is the last update for version 3.0.  In its postscript is an executable statement that will set the version if desired.

If the user proceeds to update from 3.0 to 3.1, the NAME of this changeSet will be changed to '3617suntaxBob1-raa'.  This is a trick so that further updating will begin at the right place in the update stream for version 3.1.
"!

"Postscript:
Offer the chance to advance the version number."
(self confirm: 'There are no further updates for Squeak 3.0.
Do you wish to have your system marked as version 3.1alpha
so that you may retrieve updates for version 3.1alpha and beyond?
[Some updates to 3.1alpha may put you in the role of a test-pilot].
You may choose NO now, save a backup copy
of your image, and then call for updates again.
Choose YES if you are adequately backed up and
wish to convert this Squeak image to version 3.1alpha.
DO YOU WANT TO ADVANCE to Version 3.1alpha now?')
	ifTrue: [EToySystem eToyVersion: 'Squeak3.1alpha' date: Date today.
			"Force 3.1 updates to start at the right place"
			Smalltalk changes name: '3617suntaxBob1-raa'.
			PopUpMenu notify: 'You may now save this Version 3.1alpha image
and retrieve updates again for Version 3.1alpha and beyond.']
	ifFalse: ["Prevent advancement of update number."
			Smalltalk changes name: 'Version30End' , (Time millisecondClockValue \\ 999999) printString.
			PopUpMenu notify: 'You may request updates again
to retrieve more recent updates for Version 3.0,
or to later advance this image to Version 3.1alpha.'].
!

