'From Squeak3.1alpha of 12 February 2001 [latest update: #3741] on 2 March 2001 at 4:19:57 pm'!
"Change Set:		pluginFix-bf
Date:			2 March 2001
Author:			Bert Freudenberg

Fixes the DNU #unzipped error when loading Sqeueaklets. "!


!CodeLoader methodsFor: 'installing' stamp: 'bf 3/2/2001 16:18'!
installSegment: reqEntry
	"Install the previously loaded segment"
	| contentStream contents trusted |
	contentStream _ reqEntry value contentStream.
	contentStream ifNil:[^self error:'No content to install: ', reqEntry key printString].
	trusted _ SecurityManager default positionToSecureContentsOf: contentStream.
	trusted ifFalse:[(SecurityManager default enterRestrictedMode) ifFalse:[
		(contentStream respondsTo: #close) ifTrue:[contentStream close].
		^self error:'Insecure content encountered: ', reqEntry key printString]].
	contents _ contentStream ascii upToEnd unzipped.
	(contentStream respondsTo: #close) ifTrue:[contentStream close].
	^(RWBinaryOrTextStream with: contents) reset fileInObjectAndCode install.! !

!CodeLoader methodsFor: 'installing' stamp: 'bf 3/2/2001 16:18'!
installSourceFile: aStream
	"Install the previously loaded source file"
	| contents trusted |
	aStream ifNil:[^self error:'No content to install'].
	trusted _ SecurityManager default positionToSecureContentsOf: aStream.
	trusted ifFalse:[(SecurityManager default enterRestrictedMode) ifFalse:[
		(aStream respondsTo: #close) ifTrue:[aStream close].
			^self error:'Insecure content encountered']].
	contents _ aStream ascii upToEnd unzipped.
	(aStream respondsTo: #close) ifTrue:[aStream close].
	^(RWBinaryOrTextStream with: contents) reset fileIn! !

