'From Squeak3.1alpha of 28 February 2001 [latest update: #4020] on 15 May 2001 at 9:07:17 pm'!
"Change Set:		flapsFromBrowser-sw
Date:			15 May 2001
Author:			Scott Wallace

Cleans up the situation where a 3.1a image is launched from a Browser via the ProjectLauncher."!


!Flaps class methodsFor: 'menu support' stamp: 'sw 5/15/2001 21:02'!
setUpSuppliesFlapOnly
	"Set up the Supplies flap as the only shared flap"

	| supplies |
	SharedFlapTabs isEmptyOrNil ifFalse:  "get rid of pre-existing guys if any"
		[SharedFlapTabs do:
			[:t | t referent delete.  t delete]].

	SharedFlapsAllowed _ true.
	SharedFlapTabs _ OrderedCollection new.
	SharedFlapTabs add: (supplies _ self newSuppliesFlap).
	self enableGlobalFlapWithID: 'Supplies'.
	supplies setToPopOutOnMouseOver: false.

	Smalltalk isMorphic ifTrue:
		[ActiveWorld addGlobalFlaps.
		ActiveWorld reformulateUpdatingMenus]! !


!ProjectLauncher methodsFor: 'initialization' stamp: 'sw 5/15/2001 21:06'!
setupFlaps
	"Only called when the image has been launched in a browser.  If I am requested to show etoy flaps, then remove any pre-existing shared flaps and put up the supplies flap only.  if I am requested to show all flaps, then if flaps already exist, use them as is, else set up to show the default set of standard flaps."

	whichFlaps = 'etoy'
		ifTrue:
			[Flaps setUpSuppliesFlapOnly].
	whichFlaps = 'all'
		ifTrue:
			[Flaps sharedFlapsAllowed ifFalse:
				[Flaps enableGlobalFlaps]]	! !

