'From Squeak3.1alpha of 5 February 2001 [latest update: #4097] on 29 May 2001 at 9:13:42 am'!
"Change Set:		NewSymbols1
Date:			29 May 2001
Author:			Bob Arning

(Part 1 of 2) - When creating new Symbols, add them to NewSymbols so that the entire SymbolTable does not get into roots and slow down incremental GC."!

String variableByteSubclass: #Symbol
	instanceVariableNames: ''
	classVariableNames: 'NewSymbols OneCharacterSymbols SymbolTable '
	poolDictionaries: ''
	category: 'Collections-Text'!

!Symbol class methodsFor: 'class initialization' stamp: 'RAA 5/29/2001 08:21'!
allSymbolTablesDo: aBlock

	NewSymbols do: aBlock.
	SymbolTable do: aBlock.! !

!Symbol class methodsFor: 'class initialization' stamp: 'RAA 5/29/2001 08:01'!
initialize

	"Symbol initialize"

	Symbol rehash.
	OneCharacterSymbols _ nil.
	OneCharacterSymbols _ (1 to: 256) collect: [ :i | (i - 1) asCharacter asSymbol].
! !

!Symbol class methodsFor: 'instance creation' stamp: 'RAA 5/29/2001 08:09'!
lookup: aStringOrSymbol

	^(SymbolTable like: aStringOrSymbol) ifNil: [
		NewSymbols like: aStringOrSymbol
	]! !

!Symbol class methodsFor: 'private' stamp: 'RAA 5/29/2001 08:01'!
rehash		"Symbol rehash"
	"Rebuild the hash table, reclaiming unreferenced Symbols."

	SymbolTable _ WeakSet withAll: self allInstances.
	NewSymbols _ WeakSet new.! !

Symbol class removeSelector: #fastRehash!
Symbol initialize!
Symbol class removeSelector: #slowRehash!
Symbol class removeSelector: #useArrayTables!
Symbol class removeSelector: #useHardSymbolTable!
Symbol class removeSelector: #useWeakArrayTables!
Symbol class removeSelector: #useWeakSymbolTable!
