'From Squeak 2.2 of Sept 23, 1998 on 16 November 1998 at 10:14:39 pm'!

!BookMorph methodsFor: 'navigation' stamp: 'di 11/16/1998 22:14'!
goToPage: pageNumber

	| pageIndex  oldOrigin aWorld oldRect oldPageNumber ascending newPage |
	pages isEmpty ifTrue: [^ self].

	pageIndex _ pageNumber asInteger.
	pageNumber < 1 ifTrue: [pageIndex _ pages size].
	pageNumber > pages size ifTrue: [pageIndex _ 1].
	newPage _ pages at: pageIndex.

	oldPageNumber _ pages indexOf: currentPage ifAbsent: [nil].

	ascending _ ((oldPageNumber == nil) or: [newPage == currentPage])
			ifTrue:
				[nil]
			ifFalse:
				[oldPageNumber < pageIndex].

	(aWorld _ self world) ifNotNil:
		[self primaryHand newKeyboardFocus: nil].

	self currentPage ifNotNil:
		[(oldRect _ currentPage screenRectangle) ifNotNil:
			[oldOrigin _ oldRect origin].
		self currentPlayerDo: [:aPlayer | aPlayer runAllClosingScripts].
		currentPage fullReleaseCachedState; delete].

	currentPage _ pages at: pageIndex.
	self addMorphBack: currentPage.

	self snapToEdgeIfAppropriate.

	aWorld ifNotNil:
		[self world startSteppingSubmorphsOf: currentPage.
		self showPageTurningFeedbackFromOrigin: oldOrigin ascending: ascending].
	self currentPlayerDo:
		[:aPlayer | aPlayer runAllOpeningScripts].

	(aWorld _ self world) ifNotNil: ["Nil at init time, for example" aWorld displayWorld].

! !
