'From Squeak3.2alpha of 3 October 2001 [latest update: #4578] on 4 December 2001 at 12:43:57 pm'!
"Change Set:		kbdFocusPref-sw
Date:			4 December 2001
Author:			Scott Wallace

Makes use of the lazy keyboard focus policy instituted in update 4567 depend on a preference, for the temporary rescue of those who rely on use of 'desktop command keys', until a more general solution can be put in place.  To reestablish the former keyboard-focus policy, set the mouseOverForKeyboardFocus preference to true."
Preferences addPreference: #mouseOverForKeyboardFocus categories: #(morphic) default: false  balloonHelp: 'When true, the mouse must be over a text or list pane in morphic for keystrokes to be felt, and when the mouse is out over the desktop, the so-called desktop-command-keys, such as cmd-b and cmd-R, are honored.  When false, list panes and text panes in morphic remain sensitive to keystrokes even after the mouse is no longer over the pane.'.!


!PluggableListMorph methodsFor: 'events' stamp: 'sw 12/4/2001 12:41'!
mouseLeave: event
	"The mouse has left the area of the receiver"

	super mouseLeave: event.
	Preferences mouseOverForKeyboardFocus ifTrue:
		[event hand releaseKeyboardFocus: self]! !


!PluggableTextMorph methodsFor: 'pane events' stamp: 'sw 12/4/2001 12:42'!
mouseLeave: event
	"The mouse has left the area of the receiver"

	textMorph ifNotNil: [selectionInterval _ textMorph editor selectionInterval].
	super mouseLeave: event.
	Preferences mouseOverForKeyboardFocus ifTrue:
		[event hand releaseKeyboardFocus: textMorph]! !

