'From Squeak3.3alpha of 28 January 2002 [latest update: #4780] on 27 February 2002 at 5:32:47 pm'!
"Change Set:		moreProjLoad-raa
Date:			27 February 2002
Author:			Bob Arning

when using buttons in a file list, allow the service to specify how to get arguments. already done for menu items."!


!FileList methodsFor: 'initialization' stamp: 'RAA 2/27/2002 17:26'!
blockToGetArgArrayFrom: aService

	^ [ {aService getArgumentsFrom: self} ]! !

!FileList methodsFor: 'initialization' stamp: 'RAA 2/27/2002 17:29'!
updateButtonRow
	"Dynamically update the contents of the button row, if any."

	| aWindow aRow aButton |
	Smalltalk isMorphic ifFalse: [^ self].

	aWindow _ self dependents detect: [:m | (m isKindOf: SystemWindow) and: [m model == self]] ifNone: [^ self].
	aRow _ aWindow findDeepSubmorphThat: [:m | m hasProperty: #buttonRow] ifAbsent: [^ self].

	(aRow submorphs size - 4) timesRepeat: [aRow submorphs last delete].

	self dynamicButtonServices do:
		[:service |
			aButton _  PluggableButtonMorph
							on: service provider
							getState: nil
							action: service selector.
			"aButton argumentsProvider: self argumentsSelector: #fullNameArguments."
			aButton 
				argumentsProvider: (self blockToGetArgArrayFrom: service) 
				argumentsSelector: #value.

			aButton
				color: Color transparent;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				useRoundedCorners;
				label: service buttonLabel asString;
				askBeforeChanging: true;
				onColor: Color transparent offColor: Color transparent.
			aRow addMorphBack: aButton.
			aButton setBalloonText: service description]! !