'From Squeak3.4alpha of ''11 November 2002'' [latest update: #5131] on 26 November 2002 at 1:55:02 pm'!
"Change Set:		ClassCommentFix-nk
Date:			26 November 2002
Author:			Ned Konz
Version:		3.4a

Changing class comments (and reverting them) caused walkbacks.
"!


!ChangeRecord methodsFor: 'initialization' stamp: 'nk 11/26/2002 12:07'!
fileIn
	"File the receiver in.  If I represent a method or a class-comment, file the method in and make a note of it in the recent-submissions list; if I represent a do-it, then, well, do it."

	| methodClass s aSelector |
	Cursor read showWhile:
		[(methodClass _ self methodClass) notNil ifTrue:
			[methodClass compile: self text classified: category withStamp: stamp notifying: nil.
			(aSelector _ self methodSelector) ifNotNil:
				[Utilities noteMethodSubmission: aSelector forClass: methodClass]].
		(type == #doIt) ifTrue:
			[((s _ self string) beginsWith: '----') ifFalse: [Compiler evaluate: s]].
		(type == #classComment) ifTrue:
			[ | cls | (cls _ Smalltalk at: class asSymbol) comment: self text stamp: stamp.
			Utilities noteMethodSubmission: #Comment forClass: cls ]]! !


!RemoteString methodsFor: 'accessing' stamp: 'nk 11/26/2002 12:05'!
last
	^self string ifNotNilDo: [ :s | s last ]! !

