'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5269] on 18 June 2003 at 1:18:22 pm'!
"Change Set:		GraphicsTidy
Date:			3 May 2003
Author:			Sean Charles

In the process of writing some HTML gallery helpers, I discovered that saving as JPEG uses .jpeg but that Form class>>fileReaderServicesForFile:fullName suffix:suffix did not recognise my newly saved file!! I added it to the list and it now works as I expected it to.

I then did a 'search methods' for jpg and jpeg (case insens.) and got 12 and 32 for jpg and jpeg respectively. I have spent some time investigating if there are other places where jpeg/jpg are handled differently.

The rest of this changeset provides fixes for such places.

md: removed change for Scamper.

"!


!FileList2 class methodsFor: 'blue ui' stamp: 'sjc 5/3/2003 21:38'!
endingSpecs
"sjc3-May 2003-added jpeg extension"
	^#(
		('Art' ('bmp' 'gif' 'jpg' 'jpeg' 'form' 'png')
			(('open image in a window' openImageInWindow 'View')
			('read image into ImageImports' importImage 'Import')
			('open image as background' openAsBackground 'World'))
		)

		('Morphs' ('morph' 'morphs' 'sp')
			(('load as morph' openMorphFromFile 'Morph')
			('load as project' openProjectFromFile 'Project'))
		)

		('Projects' ('extseg' 'project' 'pr') (('load as project' openProjectFromFile 'Load')))

		('Books' ('bo') (('load as book' openBookFromFile 'Open')))

		('Music' ('mid') (('play midi file' playMidiFile 'Play')))

		('Movies' ('movie') (('open as movie' openAsMovie 'Open')))

		"('Code' ('st' 'cs')
			(('fileIn' fileInSelection)
			('file into new change set' fileIntoNewChangeSet)
			('browse changes' browseChanges)
			('browse code' browseFile)
			('remove line feeds' removeLinefeeds)
			('broadcast as update' putUpdate))
		)"

		('Flash' ('swf') (('open as Flash' openAsFlash 'Open')))

		('TrueType' ('ttf') (('open true type font' openAsTTF 'Open')))

		('3ds' ('3ds') (('Open 3DS file' open3DSFile' Open')))

		('Tape' ('tape') (('open for playback' openTapeFromFile 'Open')))

		('Wonderland' ('wrl') (('open in Wonderland' openVRMLFile 'Open')))

		('HTML' ('htm' 'html') (('open in browser' openInBrowser 'Open')))

	)! !


!Form class methodsFor: 'fileIn/Out' stamp: 'sjc 5/3/2003 21:39'!
fileReaderServicesForFile: fullName suffix: suffix
"sjc3-May 2003-added jpeg extension"

	^(suffix = 'bmp') | (suffix = 'gif') | (suffix = 'jpg') | (suffix = 'jpeg') | (suffix =
'form') | (suffix = '*') | (suffix = 'png')
		ifTrue: [ self services ]
		ifFalse: [#()]
! !


!GZipWriteStream class methodsFor: 'file list services' stamp: 'sjc 5/3/2003 21:39'!
fileReaderServicesForFile: fullName suffix: suffix
	"Don't offer to compress already-compressed files
	sjc 3-May 2003-added jpeg extension"

	^({ 'gz' . 'sar' . 'zip' . 'gif' . 'jpg' . 'jpeg' } includes: suffix) ifTrue: [ #() ] ifFalse: [ self services ]

! !

