'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5278] on 27 June 2003 at 10:56:22 am'!
"Change Set:		DeadServerFix-nk
Date:			27 June 2003
Author:			Ned Konz

This changeset fixes the problem that occurs when DeadServer contains a nil (which it can depending on when it gets set).
"!


!Utilities class methodsFor: 'fetching updates' stamp: 'nk 6/26/2003 21:12'!
serverUrls 
	"Return the current list of server URLs.  For code updates.  Format of UpdateUrlLists is 
#( ('squeak updates' ('url1' 'url2'))
    ('some other updates' ('url3' 'url4')))"

	| list |
	list _ UpdateUrlLists first last.

	"If there is a dead server, return a copy with that server last" 
	Socket deadServer ifNotNil: [
		list clone withIndexDo: [:aName :ind |
		(aName beginsWith: Socket deadServer) ifTrue: [
			list _ list asOrderedCollection.	"and it's a copy"
			list removeAt: ind.
			list addLast: aName]]
	].

	^ list asArray! !

