'From Squeak 2.3 of January 14, 1999 on 10 April 1999 at 10:17:38 am'!
"Change Set:		UnCloneFloats
Date:			5 April 1999
Author:			Dan Ingalls

Reverts internal instantiation of Floats to normal instantiation instead of cloning, thus making the interpreter compatible with images that predate the provision of prototypes in the specialObjects array.

A good time to move seriously to cloning would be at the next image version change.
"!


!Interpreter methodsFor: 'plugin support' stamp: 'di 4/5/1999 20:27'!
floatObjectOf: aFloat
	| newFloatObj |
	self var: #aFloat declareC: 'double aFloat'.
	newFloatObj _ self instantiateSmallClass: (self splObj: ClassFloat) sizeInBytes: 12 fill: 0.
	self storeFloatAt: newFloatObj + BaseHeaderSize from: aFloat.
	^ newFloatObj.
! !


