'From Squeak3.1alpha of 5 February 2001 [latest update: #3519] on 6 February 2001 at 11:22:28 am'!
"Change Set:		clipboardText
Date:			6 February 2001
Author:			Bob Arning

Fix walkback when copying PostScript to clipboard. Suggested by Randal Schwartz"!


!Clipboard methodsFor: 'accessing' stamp: 'RAA 2/6/2001 11:18'!
clipboardText
	"Return the text currently in the clipboard. If the system clipboard is empty, or if it differs from the Smalltalk clipboard text, use the Smalltalk clipboard. This is done since (a) the Mac clipboard gives up on very large chunks of text and (b) since not all platforms support the notion of a clipboard."

	| s |
	s _ self primitiveClipboardText.
	(s isEmpty or: [s = contents asString])
		ifTrue: [^ contents]
		ifFalse: [^ s asText]! !

!Clipboard methodsFor: 'accessing' stamp: 'RAA 2/6/2001 11:21'!
clipboardText: text
	"Set text currently on the clipboard.  Also export to OS"
	contents _ text.
	self noteRecentClipping: text asText.
	self primitiveClipboardText: text asString! !

