'From Squeak3.1alpha of 28 February 2001 [latest update: #3855] on 16 March 2001 at 1:58:53 pm'!
AbstractLauncher subclass: #PluginLauncher
	instanceVariableNames: ''
	classVariableNames: 'SplashMorph '
	poolDictionaries: ''
	category: 'Framework-Download'!

!PluginLauncher methodsFor: 'running' stamp: 'ar 3/15/2001 23:35'!
hideSplashMorph
	SplashMorph ifNil:[^self].
	SplashMorph delete.
	World submorphs do:[:m| m visible: true]. "show all"
! !

!PluginLauncher methodsFor: 'running' stamp: 'ar 3/16/2001 12:42'!
installProjectFrom: loader
	self showSplashMorph.
	[[[
		loader installProject
	] on: ProjectViewOpenNotification
	  do:[:ex| ex resume: false] "no project view in plugin launcher"
	] on: ProgressInitiationException "no 'reading aStream' nonsense"
	  do:[:ex| ex sendNotificationsTo: [ :min :max :curr |]]
	] on: ProjectEntryNotification "hide splash morph when entering project"
       do:[:ex| self hideSplashMorph. ex pass].! !

!PluginLauncher methodsFor: 'running' stamp: 'ar 3/16/2001 12:53'!
showSplashMorph
	SplashMorph ifNil:[^self].
	World submorphs do:[:m| m visible: false]. "hide all"
	World addMorphCentered: SplashMorph.
	World displayWorldSafely.! !

!PluginLauncher methodsFor: 'running' stamp: 'ar 3/16/2001 12:42'!
startUp
	| scriptName loader |

	World ifNotNil: [World install].
	HTTPClient determineIfRunningInBrowser.
	HTTPClient isRunningInBrowser
		ifFalse: [^self].
	scriptName _ self parameterAt: 'src'.
	scriptName isEmpty ifTrue:[^self].
	CodeLoader defaultBaseURL: (self parameterAt: 'Base').
	loader _ CodeLoader new.
	loader loadSourceFiles: (Array with: scriptName).
	(scriptName asLowercase endsWith: '.pr') 
		ifTrue:[self installProjectFrom: loader]
		ifFalse:[loader installSourceFiles].
! !


!PluginLauncher class methodsFor: 'accessing' stamp: 'ar 3/15/2001 23:32'!
splashMorph
	^SplashMorph! !

!PluginLauncher class methodsFor: 'accessing' stamp: 'ar 3/15/2001 23:33'!
splashMorph: aMorph
	SplashMorph _ aMorph.! !

