'From Squeak3.1alpha of 5 February 2001 [latest update: #4013] on 11 May 2001 at 7:42:49 am'!
"Change Set:		betterSizeDefault
Date:			11 May 2001
Author:			Bob Arning

Install better default size of UT tiles. If you already have tiles that are too large, use the green dot control to scale them down"!


!SyntaxMorph methodsFor: 'menus' stamp: 'RAA 5/11/2001 07:41'!
finalAppearanceTweaks

	| deletes |
	SizeScaleFactor ifNil: [SizeScaleFactor _ 0.15]. 

	self usingClassicTiles ifTrue: [
		self allMorphsDo: [:each | 
			(each isKindOf: SyntaxMorph) ifTrue: [each lookClassic]
		].
		^self
	].

	deletes _ OrderedCollection new.
	self allMorphsDo: [ :each |
		(each respondsTo: #setDeselectedColor) ifTrue: [each setDeselectedColor].
		"(each hasProperty: #variableInsetSize) ifTrue: [
			each layoutInset: 
				((each valueOfProperty: #variableInsetSize) * SizeScaleFactor) rounded.
		]."
		(each isKindOf: SyntaxMorph) ifTrue: [
			each layoutInset: (6 * SizeScaleFactor) rounded.
		].
	].
	deletes do: [ :each | each delete].
! !

!SyntaxMorph methodsFor: 'formatting options' stamp: 'RAA 5/11/2001 07:41'!
controlSpacing2: evt

	| origin scale startingContrastX |

	evt isMouseUp ifTrue: [
		^self removeProperty: #startingPointForSomeAdjustment
	].
	evt isMouseDown ifTrue: [
		^self setProperty: #startingPointForSomeAdjustment toValue: evt cursorPoint
	].
	SizeScaleFactor ifNil: [SizeScaleFactor _ 0.15].
	scale _ 200.0.
	startingContrastX _ SizeScaleFactor * scale.
	origin _ self valueOfProperty: #startingPointForSomeAdjustment.
	SizeScaleFactor _ (evt cursorPoint x - origin x + startingContrastX) / scale min: 1.0 max: 0.0.
	self finalAppearanceTweaks.
! !

