'From Squeak3.1alpha of 5 February 2001 [latest update: #4242] on 9 August 2001 at 8:59:46 am'!
"Change Set:		ProjectHistoryFix
Date:			20 July 2001
Author:			Joshua Gargus

Swaps two lines to drastically improve performance of EToyProjectHistoryMorphs.  

The value of the project change counter is first stored, then incremented, then compared for equality against the stored value.  Of course, they were always unequal, causing much more frequent rebuilds than necessary."!


!EToyProjectHistoryMorph methodsFor: 'as yet unclassified' stamp: 'jcg 7/20/2001 18:08'!
rebuild

	| history r1 |
	history _ ProjectHistory currentHistory mostRecentCopy.
	changeCounter _ ProjectHistory changeCounter.
	self removeAllMorphs.
	self rubberBandCells: false. "enable growing"
	r1 _ self addARow: {
		self inAColumn: {
			StringMorph new contents: 'Jump...'; lock.
		}.
	}.
	r1 on: #mouseUp send: #jumpToProject to: self.

	history do: [ :each |
		(
			self addARow: {
				(self inAColumn: {
					StretchyImageMorph new form: each second; minWidth: 35; minHeight: 35; lock
				}) vResizing: #spaceFill.
				self inAColumn: {
					StringMorph new contents: each first; lock.
					"StringMorph new contents: each third; lock."
				}.
			}
		)
			color: Color paleYellow;
			borderWidth: 1;
			borderColor: #raised;
			vResizing: #spaceFill;
			on: #mouseUp send: #mouseUp:in: to: self;
			on: #mouseDown send: #mouseDown:in: to: self;
			on: #mouseMove send: #mouseMove:in: to: self;
			on: #mouseLeave send: #mouseLeave:in: to: self;
			setProperty: #projectParametersTuple toValue: each;
			setBalloonText: (each third isEmptyOrNil ifTrue: ['not saved'] ifFalse: [each third])
	].
"---
	newTuple _ {
		aProject name.
		aProject thumbnail.
		aProject url.
		WeakArray with: aProject.
	}.
---"! !

