'From Squeak3.2alpha of 4 October 2001 [latest update: #4441] on 25 October 2001 at 7:45:20 pm'!
"Change Set:		DebuggerVars-hg
Date:			14 October 2001
Author:			Henrik Gedenryd

BugFixing Party @ Camp Smalltalk OOPSLA 2001.  Fixes the Sept 19, 2001 bug report:

If you have a variable selected in one of the lower panes of the debugger, and then you select a different stack frame in the upper (stack) pane (which happens to have the same variable, e.g. 'thisContext'), the variable will stay selected and update itself (a cool new feature), but the variable list will not update (a not so cool bug)."!


!Inspector methodsFor: 'accessing' stamp: 'hg 10/14/2001 16:20'!
object: anObject 
	"Set anObject to be the object being inspected by the receiver."

	| oldIndex |
	anObject == object
		ifTrue: [self update]
		ifFalse:
			[oldIndex _ selectionIndex <= 2 ifTrue: [selectionIndex] ifFalse: [0].
			self inspect: anObject.
			oldIndex _ oldIndex min: self fieldList size.
			self changed: #inspectObject.
			oldIndex > 0
				ifTrue: [self toggleIndex: oldIndex].
			self changed: #fieldList.
			self changed: #contents]! !

