'From Squeak3.3alpha of 18 January 2002 [latest update: #4925] on 25 July 2002 at 11:54 pm'!
"Change Set:		versionBrowser-BG
Date:			25 July 2002
Author:			Boris Gaertner, Scott Wallace

Fixes a glitch that caused the creation of a spurious concrete method category named '-- all --' when a method definition was reverted in a versions browser that had been originally launched from a browser that had had the '-- all --' category selected.

Note: Boris penetrated to the core of this bug, and then produced a fix on a Squeak 2.7 system; Scott integrated Boris's fix with the post-2.7 changes to the method, and did some further trimming." !


!StringHolder methodsFor: 'message list menu' stamp: 'sw 7/25/2002 22:46'!
browseVersions
	"Create and schedule a Versions Browser, showing all versions of the currently selected message."

	| selector class |
	(selector _ self selectedMessageName) ifNotNil:
		[(MessageSet isPseudoSelector: selector) ifTrue:  "Eliminates Comment, Definition, Hierarchy"
			[^ self inform: 'Sorry, only actual methods have retrievable versions.']. 
		class _ self selectedClassOrMetaClass.
		VersionsBrowser
			browseVersionsOf: (class compiledMethodAt: selector)
			class: class
			meta: class isMeta
			category: (class organization categoryOfElement: selector)
			selector: selector]! !

