'From Squeak3.3alpha of 11 January 2002 [latest update: #4789] on 4 March 2002 at 3:03:51 pm'!

"Published to 3.3a as 4797Form-class-openImage.st"!

!Form class methodsFor: 'fileIn/Out' stamp: 'mir 3/4/2002 15:03'!
openImageInWindow: fullName
	"Handle five file formats: GIF, JPG, PNG, Form stoteOn: (run coded), and BMP.
	Fail if file format is not recognized."

	| image myStream |

	myStream _ (FileStream readOnlyFileNamed: fullName) binary.
	image _ self fromBinaryStream: myStream.
	myStream close.

	Smalltalk isMorphic ifTrue:[
		Project current resourceManager 
			addResource: image 
			url: (FileDirectory urlForFileNamed: fullName) asString.
	].

	Smalltalk isMorphic
		ifTrue: [(SketchMorph withForm: image) openInWorld]
		ifFalse: [FormView open: image named: fullName]! !
