'From Squeak3.3alpha of 18 January 2002 [latest update: #4965] on 4 September 2002 at 4:53:29 pm'!
"Change Set:		fromAppleHill-sw
Date:			4 September 2002
Author:			Scott Wallace

Published as 4966fromAppleHill-sw.cs to 3.3a.

Three issues that arose in the company of Kim and BJ at Apple Hill:
(1)  Newly drawn sketches sometimes did not show up in the playerlist of the Presenter (because its playerList cache was not getting invalidated;) thus their names would not show up in the script-name popup, and also sometimes they would not get stepped.  This is a bug that actually goes back more than four years.
(2)  Launching a PDAMorph in a system that lacked a .sources file, (such as a typical PlugIn image), would raise an error, because PDA.initialize assumed that class comments would always respond to the selector #string, which Texts do but which (perhaps surprisingly) Strings themselves do not.
(3)  For the Squeakland image, make four custom preference adjustments.
This update is intended to apply both to 3.3a and the Squeakland plug-in update streams; the preference changes will only be felt in Squeakland"!


!PDA methodsFor: 'example' stamp: 'sw 8/28/2002 23:12'!
sampleNotes

	^ {
	PDARecord new key: 'home'; description: 'sprinkler schedule'.
	PDARecord new key: 'home'; description: 'directions to our house
Take the expressway, #93 south
Then south on Rte 24
East at the T with 195
Take exit 12 and go right to Faunce Corner
Cross rte 6, continue on Old Westport Rd
takes a bend left and becomes Chase Rd
Continue for 3.5-4 mi
Rt at T intersection on Russell Mills Rd
Pass DPW on left
Lg Yellow bldg Davall''s store
left on Rocko Dundee Rd
down a swail and up.  We''re #419 on the left'.
	PDARecord new key: 'work'; description: 'archaeology memo'.
	PDARecord new key: 'work'; description: 'worlds and envts memo'.
	PDARecord new key: 'work'; description: PDA comment asString.
	}! !


!Presenter methodsFor: 'misc' stamp: 'sw 8/28/2002 23:07'!
drawingJustCompleted: aSketchMorph
	"The user just finished drawing.  Now maybe put up a viewer"

	| aWorld |
	self flushPlayerListCache.  "Because a new drawing already created one, thus obviating #assuredPlayer kicking in with its invalidation"

	aWorld _ associatedMorph world.
	(aWorld hasProperty: #automaticFlapViewing)
		ifTrue:
			[^ aWorld presenter viewMorph: aSketchMorph].

	(aSketchMorph pasteUpMorph hasProperty: #automaticViewing)
		ifTrue:
			[self viewMorph: aSketchMorph]! !

"Postscript:"
(Smalltalk version beginsWith: 'Squeakland') ifTrue:
	[Preferences enable: #propertySheetFromHalo.
	Preferences enable: #magicHalos.
	Preferences disable: #fenceSoundEnabled.
	Preferences enable: #mouseOverHalos].!

