'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 11 June 2003 at 10:05:04 pm'!
"Change Set:		KCP-0084-SystemChanges
Date:			22 May 2003
Author:			Stephane Ducasse

Define all the changes related behavior of SystemDictionary in ChangeSet to prepare the migration. 
The postscript  initializes the singleton of ChangeSet.
- add current: method that apparently disappeared. 
Fix the postscript so that it is evaluated now"!

ChangeSet class
	instanceVariableNames: 'current '!

!ChangeSet class methodsFor: 'to be removed in next changeset' stamp: 'sd 6/11/2003 22:00'!
current: aChangeSet

	current := aChangeSet! !

!ChangeSet class methodsFor: 'current changeset' stamp: 'sd 5/22/2003 19:59'!
browseChangedMessages
	"Create and schedule a message browser on each method that has been 
	changed."

	current isEmpty ifTrue: [^ self inform: 'There are no changed messages
in the current change set.'].
	ChangedMessageSet openFor: current! !

!ChangeSet class methodsFor: 'current changeset' stamp: 'sd 5/22/2003 21:53'!
current
	"return the current changeset"

	^ current! !

!ChangeSet class methodsFor: 'current changeset' stamp: 'sd 5/22/2003 22:24'!
currentChangeSetString
	"ChangeSet current currentChangeSetString"

	^ 'Current Change Set: ', self current name! !

!ChangeSet class methodsFor: 'current changeset' stamp: 'sd 5/22/2003 22:18'!
newChanges: aChangeSet 
	"Set the system ChangeSet to be the argument, aChangeSet.  Tell the current project that aChangeSet is now its change set.  When called from Project enter:, the setChangeSet: call is redundant but harmless; when called from code that changes the current-change-set from within a project, it's vital"

	current isolationSet: nil.
	current _ aChangeSet.
	Smalltalk currentProjectDo:
		[:proj |
		proj setChangeSet: aChangeSet.
		aChangeSet isolationSet: proj isolationSet]! !

!ChangeSet class methodsFor: 'current changeset' stamp: 'sd 5/22/2003 22:18'!
noChanges 
	"Initialize the system ChangeSet."

	current initialize! !

"Postscript: to get handle on the changes singleton and pass it to its new location"
ChangeSet current: Smalltalk changes
!

