'From Squeak3.6beta of ''4 July 2003'' [latest update: #5387] on 6 August 2003 at 1:53:49 pm'!
"Change Set:		RunToSelection-nk
Date:			6 August 2003
Author:			Ned Konz

6 Aug: moved menu item to top.

This adds a 'run to here' item to the Debugger code pane context menu. This lets you select some code and step until the context changes or until the PC reaches the range you've selected.
"!


!Debugger methodsFor: 'as yet unclassified' stamp: 'nk 8/6/2003 13:52'!
codePaneMenu: aMenu shifted: shifted
	aMenu add: 'run to here' target: self selector: #runToSelection: argument: thisContext sender receiver selectionInterval.
	aMenu addLine.
	super codePaneMenu: aMenu shifted: shifted.
	^aMenu.! !

!Debugger methodsFor: 'as yet unclassified' stamp: 'nk 5/31/2003 07:38'!
runToSelection: selectionInterval
	| currentContext |
	self pc first >= selectionInterval first ifTrue: [ ^self ].
	currentContext _ self selectedContext.
	[ currentContext == self selectedContext and: [ self pc first < selectionInterval first ] ] whileTrue: [ self doStep ].! !

