'From Squeak3.6beta of ''4 July 2003'' [latest update: #5373] on 27 July 2003 at 2:22:40 pm'!
"Change Set:		TestRunnerOmitAbstractTestCases-brp
Date:			27 July 2003
Author:			Brent Pinkney

When TestRunner opens or the REFRESH button is clicked, the list of test cases is calculated.

However the TestRunner conciders all subclasses of TestCase as valid test cases. It should ignore all abstract TestCase subclasses.

This change excludes all subclasses of TestCase which answer true to #isAbstract.

Tested on:
OS:		Windows 2000
VM:		3.5.1 from 21 June 21 2003
Image:	3.6beta latest changest: 5373
"!


!TestRunner methodsFor: 'processing' stamp: 'brp 7/27/2003 14:08'!
refreshTests

        tests _ (TestCase allSubclasses select: [:e | e isAbstract not] thenCollect: [:e | e name])
		asSortedCollection: [:a :b | a name asString <= b name asString].

        self changed: #tests.
        testSuite := nil.
        selectedSuite _ 0.
        selectedFailureTest _ 0.
        selectedErrorTest _ 0.
        self changed: #selectedFailureTest.             "added rew"
        self changed: #selectedErrorTest.               "added rew"
        self changed: #selectedSuite.
        self refreshWindow! !

!TestRunner methodsFor: 'initialize' stamp: 'brp 7/27/2003 14:02'!
initialize
        result _ TestResult new.
        passFail _ 'N/A'.
        details _ '...'.
        failures _ OrderedCollection new.
        errors _ OrderedCollection new.
        tests _ (TestCase allSubclasses select: [:e | e isAbstract not] thenCollect: [:e | e name])
		asSortedCollection: [:a :b | a name asString <= b name asString].
        selectedSuite _ 0.
        selectedFailureTest _ 0.
        selectedErrorTest _ 0.
! !

