'From Squeak3.6gamma of ''11 September 2003'' [latest update: #5421] on 28 September 2003 at 2:52:34 pm'!
"Change Set:		ScriptableButtonFix
Date:			28 September 2003
Author:			Yoshiki Ohshima

If you bring up a ScriptableButton from the Supplies flap and press the cyan button to get the scriptor, it raises an error.  This changeset trys to fix the problem."!


!ScriptableButton methodsFor: 'script' stamp: 'yo 9/28/2003 14:49'!
editButtonsScript
	"The user has touched my Scriptor halo-handle.  Bring up a Scriptor on the script of the button."

	| cardsPasteUp cardsPlayer anEditor |
	cardsPasteUp := self pasteUpMorph.
	(cardsPlayer := cardsPasteUp assuredPlayer) assureUniClass.
	anEditor := scriptSelector ifNil: 
					[scriptSelector := cardsPasteUp scriptSelectorToTriggerFor: self.
					cardsPlayer newTextualScriptorFor: scriptSelector.
					cardsPlayer scriptEditorFor: scriptSelector
					]
				ifNotNil: 
					[(cardsPlayer class selectors includes: scriptSelector) 
						ifTrue: [cardsPlayer scriptEditorFor: scriptSelector]
						ifFalse: 
							["Method somehow got removed; I guess we start afresh"

							scriptSelector := nil.
							^self editButtonsScript]].
	self currentHand attachMorph: anEditor! !

