'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 4 November 2003 at 6:11:39 pm'!
"Change Set:		TTTextStyle5-fix-dgd
Date:			4 November 2003
Author:			Diego Gomez Deck <DiegoGomezDeck@ConsultAr.com>

The previous version was serializing the font information using #name and des-serializing using #descriptionNamed: causing the lost of bold/italic information.

This fix serialize using #fullName (and des-serialize using #descriptionFullNamed:) fixing the previous bug without breaking the serialization of objects serialized with the bug.
"!


!TTFontDescription methodsFor: 'copying' stamp: 'dgd 11/4/2003 18:08'!
objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  Write a reference to a known Font in the other system instead.  "

	"A path to me"
	(TextConstants at: #forceFontWriting ifAbsent: [false]) ifTrue: [^ self].
		"special case for saving the default fonts on the disk.  See collectionFromFileNamed:"

	dp _ DiskProxy global: #TTFontDescription selector: #descriptionNamed:
			args: {self fullName}.
	refStrm replace: self with: dp.
	^ dp.
! !


!TTFontDescription class methodsFor: 'instance creations' stamp: 'dgd 11/4/2003 17:54'!
descriptionFullNamed: descriptionFullName 
	^ Descriptions
		detect: [:f | f fullName = descriptionFullName]
		ifNone: [Default]! !

