'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 2 February 2004 at 12:33:27 am'!
"Change Set:		intNewFix-bf
Date:			2 February 2004
Author:			Bert Freudenberg

Fixes a bug in Integer class>>byte1:byte2:byte3:byte4: reported by Peter William Lount"!


!Integer class methodsFor: 'instance creation' stamp: 'bf 2/2/2004 00:23'!
byte1: byte1 byte2: byte2 byte3: byte3 byte4: byte4 
	"Depending on high-order byte copy directly into a LargeInteger,
	or build up a SmallInteger by shifting"
	| value |
	byte4 < 16r40 ifTrue:
		[^ (byte4 bitShift: 24)
		 + (byte3 bitShift: 16)
		 + (byte2 bitShift: 8)
		 + byte1].
	value _ LargePositiveInteger new: 4.
	value digitAt: 4 put: byte4.
	value digitAt: 3 put: byte3.
	value digitAt: 2 put: byte2.
	value digitAt: 1 put: byte1.
	^ value! !

