'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 16 February 2004 at 11:17:30 am'!
"Change Set:		ChangedWith-nk
Date:			17 February 2004
Author:			Ned Konz

This adds #changed:with: and #update:with: to Object, as discussed on 2 and 3 December 2003.

This is also VisualWorks compatible, for those packages that are ported from VW.

"!


!Object methodsFor: 'updating' stamp: 'nk 2/17/2004 11:12'!
changed: anAspect with: anObject
	"Receiver changed. The change is denoted by the argument anAspect. 
	Usually the argument is a Symbol that is part of the dependent's change 
	protocol. Inform all of the dependents. Also pass anObject for additional information."

	self dependents do: [:aDependent | aDependent update: anAspect with: anObject]! !

!Object methodsFor: 'updating' stamp: 'nk 2/17/2004 11:13'!
update: anAspect with: anObject
	"Receive a change notice from an object of whom the receiver is a 
	dependent. The default behavior is to call update:,
	which by default does nothing; a subclass might want 
	to change itself in some way."

	^ self update: anAspect! !

