'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 1 March 2004 at 5:35:04 pm'!
"Change Set:		SimpleHierarchyExample
Date:			1 March 2004
Author:			Lex Spoon

A simple example usage of SimpleHierarchicalListMorph.  Also adds a comment to SimpleHierarchicalListMorph."!

ListItemWrapper subclass: #MorphWithSubmorphsWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Explorer'!

!MorphWithSubmorphsWrapper commentStamp: 'ls 3/1/2004 17:32' prior: 0!
Display a morph in a SimpleHierarchicalListMorph, and arrange to recursively display the morph's submorphs.  The "item" that is wrapped is the morph to display.!


!SimpleHierarchicalListMorph commentStamp: 'ls 3/1/2004 12:15' prior: 0!
Display a hierarchical list of items.  Each item should be wrapped with a ListItemWrapper.

For a simple example, look at submorphsExample.  For beefier examples, look at ObjectExplorer or FileList2.!
]style[(122 16 33 14 4 9 1)f1,f1LSimpleHierarchicalListMorph class submorphsExample;,f1,f1LObjectExplorer Definition;,f1,f1LFileList2 Definition;,f1!


!MorphWithSubmorphsWrapper methodsFor: 'hierarchy' stamp: 'ls 3/1/2004 17:34'!
contents
	^item submorphs collect: [ :m |
		self class with: m ]! !


!SimpleHierarchicalListMorph class methodsFor: 'examples' stamp: 'ls 3/1/2004 17:32'!
submorphsExample
	"display a hierarchical list of the World plus its submorphs plus its submorphs' submorphs etc."
	"[SimpleHierarchicalListMorph submorphsExample]"
	| morph |
	morph :=
		SimpleHierarchicalListMorph
			on: [ Array with:  (MorphWithSubmorphsWrapper with: World)  ]
			list: #value
			selected: nil
			changeSelected: nil
			menu: nil
			keystroke: nil.

	morph openInWindow! !

