'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 21 February 2004 at 2:30:28 am'!
!ObjectsTool methodsFor: 'initialization' stamp: 'KLC 2/21/2004 02:28'!
initializeToStandAlone
	"Initialize the receiver so that it can live as a stand-alone morph"
	| aPane aBin aColor |
	self basicInitialize.
	self layoutInset: 6. 
	self listCentering: #topLeft.
	self cellPositioning: #topLeft.
	self wrapCentering: #center.
	self useRoundedCorners.
	self listDirection: #topToBottom.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	aPane _ self paneForTabs: self modeTabs.
	aPane addMorphFront: self dismissButton.
	aPane addMorphBack: self helpButton.
	aPane color: (aColor _ aPane color) darker.
	aPane listSpacing: #equal.
	aPane cellInset: 10 @ 10.
	aPane listCentering: #center; height: 38.
	aPane wrapDirection: nil.
	self addMorphFront: aPane.
	self addMorphBack: Morph new.  "Place holder for a tabs or text pane"
	aBin _ PartsBin newPartsBinWithOrientation: #leftToRight from: #().
	aBin listDirection: #leftToRight.
	aBin wrapDirection: #topToBottom.
	aBin hResizing: #spaceFill; vResizing: #spaceFill.
	aBin extent: (self currentWorld width) @ 300.
	aBin color: aColor lighter lighter.
	aBin setNameTo: 'parts'.
	aBin dropEnabled: false.
	self addMorphBack: aBin.
	self submorphs last width: 350; hResizing: #rigid.
	self color: (Color r: 0.0 g: 0.839 b: 0.226).
	self setProperty: #initialWidth toValue: 268.
	self setNameTo: 'Objects' translated.
	self showCategories.
! !