'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 21 February 2004 at 7:18:26 pm'!
"Change Set:		secondPrecisionDateAndTimeNow-avi
Date:			21 February 2004
Author:			Avi Bryant

This fixes DateAndTime class>>now to ignore the millisecond clock and simply return an accurate value with 1 second precision.  It also clears out the class variables and #startUp/#initialize methods that were being used to attempt to get (inaccurate) millisecond precision."!

Magnitude subclass: #DateAndTime
	instanceVariableNames: 'seconds offset jdn nanos '
	classVariableNames: 'FirstMilliSecondValue LastTick LastTickSemaphore LocalTimeZone '
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!

!DateAndTime class methodsFor: 'ansi protocol' stamp: 'avi 2/21/2004 19:03'!
now
	^ self basicNew 
		ticks: (Duration 
				days: SqueakEpoch 
				hours: 0 
				minutes: 0 
				seconds: self totalSeconds 
				nanoSeconds: 0) ticks
		offset: self localOffset;
		yourself
! !

DateAndTime class removeSelector: #initialize!
DateAndTime class removeSelector: #startUp!
Magnitude subclass: #DateAndTime
	instanceVariableNames: 'seconds offset jdn nanos'
	classVariableNames: 'LocalTimeZone'
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!










