'From Squeak3.7beta of ''1 April 2004'' [latest update: #5868] on 5 April 2004 at 11:32:09 am'!
"Change Set:		PLMOfManyModelAccessFix-hpt
Date:			5 April 2004
Author:			Hernn Tylim

I found on PluggableListMorphOfMany an access to the model that wasn't using the selectors that were given by the user but a hardcoded #listSelectionAt:. 

Because this force the user to implement #listSelectionAt: on the model, and because the class is already using a pluggable way to access the selection, this .cs removes the hardcoded call (the only one in the class in #itemSelectedAmongMultiple:) for a self listSelectionAt: which access the model in the right way.
 
Also it fixes the class comment where was stated that the model must implement #listSelectionAt: and #listSelectionAt:put:. The latter were not used"!


!PluggableListMorphOfMany commentStamp: 'hpt 4/5/2004 11:21' prior: 0!
A variant of its superclass that allows multiple items to be selected simultaneously.  There is still a distinguished element which is selected, but each other element in the list may be flagged on or off.
!


!PluggableListMorphOfMany methodsFor: 'model access' stamp: 'hpt 4/5/2004 11:00'!
itemSelectedAmongMultiple: index
	^self listSelectionAt: index! !

