'From Squeak3.7beta of ''1 April 2004'' [latest update: #5878] on 20 April 2004 at 2:25:04 pm'!
"Change Set:		TimeStampRefactorForSmallWiki-fbs
Date:			20 April 2004
Author:			Frank Shearar

SmallWiki changes TimeStamp class>>now to '^self current'. TimeStamp class>>current (as of 3.7-5829) says '^self now'. This, of course, causes an infinite recursion. This changeset reverses #current and #now's relationship so as to avoid this issue. This changeset represents a refactoring, so behaviour won't change."!


!TimeStamp class methodsFor: 'squeak protocol' stamp: 'fbs 4/20/2004 14:21'!
current

	| ts ticks |
	ts _ super now.
	
	ticks _ ts ticks.
	ticks at: 3 put: 0.
	ts ticks: ticks offset: ts offset.
	
	^ ts
		
! !

!TimeStamp class methodsFor: 'ansi protocol' stamp: 'fbs 4/20/2004 14:22'!
now
	"Answer the current date and time as a TimeStamp."

	^self current! !


!TimeStamp class reorganize!
('deprecated' midnightOn: noonOn:)
('*monticello-instance creation' fromMethodTimeStamp: fromString: readFrom:)
('squeak protocol' current)
('ansi protocol' now)
!

