'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 24 July 2004 at 4:58:28 pm'!
"Change Set:		BGScrMorphs-fc
Date:			24 July 2004
Author:			Frank Caggiano

Adds setters/getters to BackgroundMorph and ScreeningMorph to make them more programmer friendly. 

Removed erroneous method commment from BackgroundMorph>>step.
"!


!BackgroundMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 12:23'!
delta
	^delta! !

!BackgroundMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 12:24'!
delta: aPoint

	delta _ aPoint.! !

!BackgroundMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 13:50'!
offset
	^offset! !

!BackgroundMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 13:50'!
offset: aPoint
	offset _ aPoint! !

!BackgroundMorph methodsFor: 'stepping and presenter' stamp: 'fc 7/24/2004 13:47'!
step
	
	running ifTrue: [self slideBy: delta]! !


!ScreeningMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 13:43'!
passElseBlock: aBool
	passElseBlock _ aBool.! !

!ScreeningMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 13:42'!
passingColor: aColor
	passingColor _ aColor.! !


!ScreeningMorph reorganize!
('drawing' fullDrawOn:)
('geometry testing' containsPoint:)
('initialization' initialize)
('layout' layoutChanged)
('menu' addCustomMenuItems:hand: chooseBlockingColor choosePassingColor exchange showScreenOnly showScreenOverSource showScreened showSourceOnly)
('accessing' passElseBlock: passingColor:)
('submorphs-add/remove' addMorph:)
('private' removedMorph: screenForm screenMorph sourceMorph)
!


!BackgroundMorph reorganize!
('accessing' delta delta: offset offset: slideBy: startRunning stopRunning subBounds)
('drawing' drawOn: fullDrawOn:)
('initialization' initialize)
('layout' fullBounds layoutChanged)
('menus' addCustomMenuItems:hand:)
('stepping and presenter' step)
('testing' stepTime)
!

