'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #267] on 28 August 2004 at 2:21:02 pm'!
"Change Set:		TabAmongFields-fix-dgd
Date:			28 August 2004
Author:			Diego Gomez Deck

Surfing on Morph's methods I discovered the option to switch focus from TextMorphs to TextMorphs just using tag key.

To try this a property in World is needed:

	World  setProperty: #tabAmongFields toValue: true.

This changeset removes an unneded check for isLocked in TextMorph and fix an error in Morph>>tabHitWithEvent:.

Enjot it
"!


!Morph methodsFor: 'card in a stack' stamp: 'dgd 8/28/2004 13:56'!
tabHitWithEvent: anEvent
	"The tab key was hit.  The keyboard focus has referred this event to me, though this perhaps seems rather backwards.  Anyway, the assumption is that I have the property #tabAmongFields, so now the task is to tab to the next field."

	| currentFocus fieldList anIndex itemToHighlight variableBearingMorphs otherAmenableMorphs |
	currentFocus _ anEvent hand keyboardFocus.
	fieldList _ self allMorphs select:
		[:aMorph | (aMorph wouldAcceptKeyboardFocusUponTab) and: [aMorph isLocked not]].

	variableBearingMorphs _ self player isNil
										ifTrue:[#()]
										ifFalse:[self player class variableDocks collect: [:vd | vd definingMorph] thenSelect: [:m | m isInWorld]].
	otherAmenableMorphs _ (self allMorphs select:
		[:aMorph | (aMorph wouldAcceptKeyboardFocusUponTab) and: [aMorph isLocked not]])
			copyWithoutAll: variableBearingMorphs.
	fieldList _ variableBearingMorphs, otherAmenableMorphs.

	anIndex _ fieldList indexOf: currentFocus ifAbsent: [nil].
	itemToHighlight _ fieldList atWrap: 
		(anIndex ifNotNil: [anEvent shiftPressed ifTrue: [anIndex - 1] ifFalse: [anIndex + 1]]
				ifNil: [1]).
	anEvent hand newKeyboardFocus: itemToHighlight. self flag: #arNote. "really???"
	itemToHighlight editor selectAll.
	itemToHighlight invalidRect: itemToHighlight bounds ! !


!TextMorph methodsFor: 'event handling' stamp: 'dgd 8/28/2004 13:54'!
wouldAcceptKeyboardFocusUponTab
	"Answer whether the receiver might accept keyboard focus if 
	tab were hit in some container playfield"
	^ self inPartsBin not! !

