'From Squeak3.7beta of ''1 April 2004'' [latest update: #5878] on 26 April 2004 at 5:40:56 pm'!
"Change Set:		FlapsRegistryFix-hpt
Date:			26 April 2004
Author:			Hernan Tylim

This changeset just add a forgotten nil check on #registeredFlapsQuadsAt:. 
In a 5878 when recreating the flaps (*after* re-initializing the quads, use Flaps initializeFlapsQuads) you get a walkback because #Scamper is not in the SystemDictionary.
Note that #registeredFlapsQuadsAt:  was already filtering invalid quads but the condition was not complete." !


!Flaps class methodsFor: 'flaps registry' stamp: 'hpt 4/26/2004 16:46'!
registeredFlapsQuadsAt: aLabel
	"Answer the list of dynamic flaps quads at aLabel"

	^ (self registeredFlapsQuads at: aLabel)
		removeAllSuchThat: [:q | (self environment includesKey: q first) not or: [(self environment at: q first) isNil]]
! !

