'From Squeak3.8alpha of ''17 July 2004'' [latest update: #6285] on 2 October 2004 at 11:08:16 am'!
"Change Set:		6290DeprecatedRuleDate
Date:			2 October 2004
Author:			Stephane Ducasse

deprecate the classes rule date and related according to the cs of brent (the author of chronology package)"!


!RuleDate commentStamp: '<historical>' prior: 0!
This class is deprecated. Use the chronology package classes



RuleDate instances represent dates determined by some rule (first Tuesday in March, etc.) but the exact day of the month varies from year to year.  Once created they must be updated for a selected year to represent the exact day of that year.

Typical Use:

	RuleDate instances are suitable for representing dates such as election day, or the start of daylight saving time in the USA.

Implementation:

Instance variables:

	dayOfWeek		- a <Symbol> representing the day name of the
					week (Sunday, etc) of the desired day.
	selectionRule	- a <Symbol> representing the position (first, last)
					of the desired day in the list of days occurring
					on that day of the week in the desired month.
!


!RuleIndexDate commentStamp: '<historical>' prior: 0!
This class is deprecated. Use the chronology package classes


RuleIndexDate instances represent dates determined by some rule but the exact day of the month varies from year to year.  Once created they must be updated for a selected year to represent the exact day of that year.
	It has a rule that selects exact day of the month based on the ordinal position (1, 2, etc.) of the desired day in the list of days occurring on that day of the week in the desired month.

Typical Use:

	RuleIndexDate instances are suitable for representing dates such as Thanksgiving Day (fourth Tuesday in November) in the USA.

Implementation:

Instance variables:

	(selectionRule in super class)	- an <Integer> representing the
			ordinal position (1, 2, etc.) of the desired day in the list
			of days occurring on that day of the week in the desired
			month.
!


!RuleSelectionCodeDate commentStamp: '<historical>' prior: 0!
This class is deprecated. Use the chronology package classes


RuleSelectionCodeDate instances represent dates determined by some rule but the exact day of the month varies from year to year.  Once created they must be updated for a selected year to represent the exact day of that year.
	It has a rule that selects exact day of the month by evaluating the selection block with the list of days occurring on that day of the week in the desired month as an argument.

Typical Use:

	RuleSelectionCodeDate instances are suitable for representing dates such as the last day of daylight saving time (the Saturday before the last Sunday in October) in the USA.

Implementation:

Instance variables:

	(selectionRule in super class)	- a <monadicValuable> containing
			the selection block to be evaluated.  The argument is the list
			of days occurring on that day of the week in the desired
			month.  It must return the desired day of the month 			which may be any <Integer>.
!


!RuleDate class methodsFor: 'deprecated' stamp: 'sd 10/2/2004 11:05'!
basicNew

	self deprecated: 'Do not use this class anymore'.
	^ super basicNew! !


!RuleIndexDate class methodsFor: 'deprecated' stamp: 'sd 10/2/2004 11:07'!
basicNew

	self deprecated: 'Do not use this class anymore'.
	^ super basicNew! !


!RuleSelectionCodeDate class methodsFor: 'deprecated' stamp: 'sd 10/2/2004 11:07'!
basicNew

	self deprecated: 'Do not use this class anymore'.
	^ super basicNew! !


!RuleSelectionCodeDate class reorganize!
('private' getValidSelectionRule:)
('instance creation' selected:inMonth:year:byCode:)
('deprecated' basicNew)
!


!RuleIndexDate class reorganize!
('instance creation' indexed:inMonth:year:at:)
('private' getValidSelectionRule:)
('deprecated' basicNew)
!


!RuleDate class reorganize!
('private' getValidMonthNumber: getValidSelectionRule: newDayOfWeek:selectionRule:)
('deprecated' basicNew)
('instance creation' first:inMonth:year: last:inMonth:year:)
!

