'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #324] on 7 September 2004 at 6:22:49 pm'!
"Change Set:		mpegOpenFix-sw
Date:			7 September 2004
Author:			Scott Wallace

Installs an MPEGMoviePlayerMorph service for opening (as opposed to playing) and removes the 'open' service that MoviePlayerMorph formerly had asserted."!


!MPEGMoviePlayerMorph class methodsFor: 'fileIn/Out' stamp: 'sw 9/7/2004 18:17'!
services 
	"Answer the receiver's services"

     ^ OrderedCollection with: self servicePlayInMPEGPlayer with: self serviceOpenInMPEGPlayer
! !

!MPEGMoviePlayerMorph class methodsFor: 'registering' stamp: 'sw 9/7/2004 18:22'!
openFile: aFileName
	"Open the given file (if not nil) in an instance of the receiver."

     | wrapper |
	aFileName ifNil: [^ Beeper beep].
     wrapper _ self openOn: aFileName.
 	wrapper openInWorld.
     ^ wrapper! !

!MPEGMoviePlayerMorph class methodsFor: 'registering' stamp: 'sw 9/7/2004 18:22'!
playFile: aFileName
	"Play the given file (if not nil) in an MPEGMoviePlayerMorph"

     | wrapper |
	aFileName ifNil: [^ Beeper beep].
     wrapper _ self openOn: aFileName.
     wrapper moviePlayer startPlaying. 
     "wrapper openInWindow."
	wrapper openInWorld.
     ^wrapper! !

!MPEGMoviePlayerMorph class methodsFor: 'registering' stamp: 'sw 9/7/2004 18:17'!
serviceOpenInMPEGPlayer
	"Answer a service for opening a file in an MPEGMoviePlayer"

	^ SimpleServiceEntry 
		provider: self 
		label: 'open'
		selector: #openFile:
		description: 'open file in an MPEG player'
		buttonLabel: 'open'! !


!MoviePlayerMorph class methodsFor: 'fileIn/Out' stamp: 'sw 9/7/2004 18:21'!
services
	"Formerly: answer a service for opening as a movie.  Nowadays... no services"

	^ #().
"
	^ Array with: self serviceOpenAsMovie"

	! !

