'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #324] on 20 September 2004 at 3:24:54 pm'!
"Change Set:		blackNameInHalo-sw
Date:			20 September 2004
Author:			Scott Wallace

Show the halo name in black, except when it's under edit, when it's shown in red, just like all other strings under edit."!


!HaloMorph methodsFor: 'private' stamp: 'sw 9/20/2004 15:19'!
addNameBeneath: outerRectangle string: aString
	"Add a name display centered beneath the bottom of the outer rectangle. Return the handle."

	| nameMorph namePosition w |
	w _ self world ifNil:[target world].
	nameMorph _ NameStringInHalo contents: aString font: Preferences standardHaloLabelFont.
	nameMorph color: Color black.
	nameMorph useStringFormat; target: innerTarget; putSelector: #tryToRenameTo:.
	namePosition _ outerRectangle bottomCenter -
		((nameMorph width // 2) @ (self handleSize negated // 2 - 1)).
	nameMorph position: (namePosition min: w viewBox bottomRight - nameMorph extent y + 2).
	nameMorph balloonTextSelector: #objectNameInHalo.
	self addMorph: nameMorph.
	^ nameMorph! !

