'From Squeak3.8beta of ''2 November 2004'' [latest update: #6461] on 22 November 2004 at 5:29:56 pm'!
"Change Set:		asMutatorEnh-st
Date:			22 November 2004
Author:			Samuel Tardieu

It is common to use the expression

  (aSymbol, ':') asSymbol

to build the setter from a getter message. For example, Seaside uses it internally for building callbacks. This changeset adds the #asMutator message to the Symbol class.

Test included.
"!


!Symbol methodsFor: 'converting' stamp: 'st 11/22/2004 17:26'!
asMutator
	"Return a setter message from a getter message. For example,
	#name asMutator returns #name:"
	^ (self copyWith: $:) asSymbol! !


!SymbolTest methodsFor: 'testing' stamp: 'st 11/22/2004 17:27'!
testAsMutator
	self assert: #x asMutator = #x:.
	self assert: #x asMutator class = Symbol! !


!Symbol reorganize!
('accessing' at:put: precedence replaceFrom:to:with:startingAt:)
('comparing' =)
('copying' clone copy shallowCopy veryDeepCopyWith:)
('converting' asMutator asString asSymbol capitalized withFirstCharacterDownshifted)
('printing' isOrientedFill storeOn:)
('system primitives' flushCache)
('private' errorNoModification species string:)
('filter streaming' byteEncode:)
('testing' isInfix isKeyword isLiteral isPvtSelector isSymbol isUnary)
('user interface' asExplorerString)
('Camp Smalltalk' sunitAsClass)
('*Keymapping' actionString)
('*BrowseUnit' asTestCaseSelector isTest)
!

