'From Squeak3.9alpha of 4 July 2005 [latest update: #7020] on 26 March 2006 at 1:24:53 pm'!

Metaclass
	addInstVarName: 'tempTraitComposition';
	addInstVarName: 'tempLocalSelectors'.
		
Metaclass allInstancesDo: [ :each |
	each instVarNamed: 'tempTraitComposition' put: (each instVarNamed: 'traitComposition').
	each instVarNamed: 'tempLocalSelectors' put: (each instVarNamed: 'localSelectors') ].!
	
!Metaclass methodsFor: 'accessing' stamp: 'al 3/25/2006 13:16'!
basicLocalSelectors
	"Direct accessor for the instance variable localSelectors.
	Since localSelectors is lazily initialized, this may 
	return nil, which means that all selectors are local."

	^ tempLocalSelectors! !

!Metaclass methodsFor: 'accessing' stamp: 'al 3/25/2006 13:16'!
basicLocalSelectors: aSetOrNil
	tempLocalSelectors _ aSetOrNil! !

!Metaclass methodsFor: 'accessing' stamp: 'al 3/26/2006 11:32'!
hasTraitComposition
	^tempTraitComposition notNil! !

!Metaclass methodsFor: 'accessing' stamp: 'al 3/25/2006 12:35'!
traitComposition
	tempTraitComposition ifNil: [tempTraitComposition _ TraitComposition new].
	^tempTraitComposition! !

!Metaclass methodsFor: 'accessing' stamp: 'al 3/25/2006 12:38'!
traitComposition: aTraitComposition
	tempTraitComposition _ aTraitComposition! !
	
!Class methodsFor: 'accessing' stamp: 'al 3/25/2006 13:16'!
basicLocalSelectors
	"Direct accessor for the instance variable localSelectors.
	Since localSelectors is lazily initialized, this may 
	return nil, which means that all selectors are local."

	^ localSelectors! !

!Class methodsFor: 'accessing' stamp: 'al 3/25/2006 13:16'!
basicLocalSelectors: aSetOrNil
	localSelectors _ aSetOrNil! !

!Class methodsFor: 'accessing' stamp: 'al 3/25/2006 12:38'!
hasTraitComposition
	^traitComposition notNil! !

!Class methodsFor: 'accessing' stamp: 'al 3/25/2006 12:35'!
traitComposition
	traitComposition ifNil: [traitComposition _ TraitComposition new].
	^traitComposition! !

!Class methodsFor: 'accessing' stamp: 'al 3/25/2006 12:37'!
traitComposition: aTraitComposition
	traitComposition := aTraitComposition! !
	
!Behavior methodsFor: 'accessing method dictionary' stamp: 'al 3/25/2006 13:17'!
basicLocalSelectors
	self subclassResponsibility ! !

!Behavior methodsFor: 'accessing method dictionary' stamp: 'al 3/25/2006 13:17'!
basicLocalSelectors: aSetOrNil
	self subclassResponsibility ! !

!Behavior methodsFor: 'traits' stamp: 'al 3/25/2006 12:39'!
hasTraitComposition
	self subclassResponsibility ! !

!Behavior methodsFor: 'traits' stamp: 'al 3/25/2006 12:36'!
traitComposition
	self subclassResponsibility! !

!Behavior methodsFor: 'traits' stamp: 'al 3/25/2006 12:39'!
traitComposition: aTraitComposition
	self subclassResponsibility ! !
	

ClassBuilder new
	moveInstVarNamed: 'traitComposition'
	from: Behavior
	to: Class
	after: 'category'.
	
ClassBuilder new
	moveInstVarNamed: 'localSelectors'
	from: Behavior
	to: Class
	after: 'traitComposition'.!
	

ClassDescription subclass: #Metaclass
	uses: TApplyingOnClassSide
	instanceVariableNames: 'thisClass traitComposition localSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!Metaclass methodsFor: 'accessing' stamp: 'al 3/25/2006 13:16'!
basicLocalSelectors
	"Direct accessor for the instance variable localSelectors.
	Since localSelectors is lazily initialized, this may 
	return nil, which means that all selectors are local."

	^ localSelectors! !

!Metaclass methodsFor: 'accessing' stamp: 'al 3/25/2006 13:16'!
basicLocalSelectors: aSetOrNil
	localSelectors _ aSetOrNil! !

!Metaclass methodsFor: 'accessing' stamp: 'al 3/26/2006 11:32'!
hasTraitComposition
	^traitComposition notNil! !

!Metaclass methodsFor: 'accessing' stamp: 'al 3/25/2006 12:35'!
traitComposition
	traitComposition ifNil: [traitComposition _ TraitComposition new].
	^traitComposition! !

!Metaclass methodsFor: 'accessing' stamp: 'al 3/25/2006 12:38'!
traitComposition: aTraitComposition
	traitComposition _ aTraitComposition! !
