'From Squeak 2.4b of April 23, 1999 on 20 July 1999 at 2:50:27 pm'!
"Change Set:		CGFix-ar
Date:			20 July 1999
Author:			Andreas Raab

Fixes the code generator not to prune any exported methods (e.g., primitives that are called by name)."!


!CCodeGenerator methodsFor: 'utilities' stamp: 'ar 7/17/1999 15:06'!
unreachableMethods
	"Return a collection of methods that are never invoked."

	| sent out |
	sent _ Set new.
	methods do: [ :m |
		m export ifTrue:[sent add: m selector].
		sent addAll: m allCalls.
	].

	out _ OrderedCollection new.
	methods keys do: [ :sel |
		(sent includes: sel) ifFalse: [ out add: sel ].
	].
	^ out! !


