'From Squeak 2.4b of April 23, 1999 on 30 July 1999 at 4:58:24 pm'!
"Change Set:		PrimMakePointFix-ar
Date:			30 July 1999
Author:			Andreas Raab

And a fix for the last change set since I forget that allocating a point may cause a GC :-("!


!Interpreter methodsFor: 'arithmetic primitives' stamp: 'ar 7/30/1999 16:57'!
primitiveMakePoint
	| rcvr argument pt |
	argument _ self stackValue: 0.
	rcvr _ self stackValue: 1.
	(self isIntegerObject: rcvr) ifTrue:[
		(self isIntegerObject: argument)
			ifTrue:[pt _ self makePointwithxValue: (self integerValueOf: rcvr)
							yValue: (self integerValueOf: argument)]
			ifFalse:[pt _ self makePointwithxValue: (self integerValueOf: rcvr)
							yValue: 0.
					"Above may cause GC!!"
					self storePointer: 1 ofObject: pt withValue: (self stackValue: 0)].
	] ifFalse:[
		(self isFloatObject: rcvr) ifFalse:[^self success: false].
		pt _ self makePointwithxValue: 0 yValue: 0.
		"Above may cause GC!!"
		self storePointer: 0 ofObject: pt withValue: (self stackValue: 1).
		self storePointer: 1 ofObject: pt withValue: (self stackValue: 0).
	].
	self pop: 2.
	self push: pt.
! !


