'From Squeak 2.5 of August 6, 1999 on 3 September 1999 at 12:56:38 pm'!
"Change Set:		EllipseFix-ar
Date:			3 September 1999
Author:			Andreas Raab

Fixes a drawing problem for ellipses with completely transparent borders. Also removes the old ellipse drawing method from GrafPort."!


!FormCanvas methodsFor: 'drawing-ovals' stamp: 'ar 9/3/1999 12:54'!
fillOval: r color: c borderWidth: borderWidth borderColor: borderColor
	| rect fillC borderC borderRule |
	rect _ r.
	c isTransparent
		ifTrue: [fillC _ nil]
		ifFalse: [fillC _ self drawColor: c].
	borderColor isTransparent
		ifTrue: [fillC == nil ifTrue: [^ self].  "both border and fill are transparent"
				borderC _ nil]
		ifFalse: [borderC _ self drawColor: borderColor.
				borderRule _ self drawRule: Form over color: borderColor].

	port combinationRule: (self drawRule: Form over color: c).
	port fillOval: (rect translateBy: origin)
		color: fillC
		borderWidth: borderWidth
		borderColor: borderC
		borderRule: borderRule.
! !


GrafPort removeSelector: #fillOval:color:borderWidth:borderColor:!
