'From Squeak 2.5 of August 6, 1999 on 8 September 1999 at 11:55:16 am'!
"Change Set:		MorphicUndoFix
Date:			8 September 1999
Author:			Dan Ingalls

Simple fix to a problem reported by Bert Freudenberg, as follows...

Type something in a workspace, select something in the middle, type something and then choose undo from the menu. Nothing happens. Until you select something in the text and see odd character fragments appear. After a redraw or a keypress it behaves normally, but id didn't do the right undo op.

It seems to work OK now."!


!TextMorphEditor methodsFor: 'events' stamp: 'di 9/8/1999 11:48'!
mouseDown: evt 
	"An attempt to break up the old processRedButton code into threee phases"
	| clickPoint |
	oldInterval _ startBlock stringIndex to: stopBlock stringIndex - 1.
	clickPoint _ evt cursorPoint.
	(paragraph clickAt: clickPoint for: model controller: self) ifTrue: [
		evt hand newKeyboardFocus: nil.
		^ self].
	sensor leftShiftDown
		ifFalse:
			[self closeTypeIn.
			stopBlock _ startBlock _ pivotBlock _
				paragraph characterBlockAtPoint: clickPoint]
		ifTrue:
			[(paragraph characterBlockAtPoint: clickPoint) <= startBlock
				ifTrue: [stopBlock _ startBlock.
						pivotBlock _ stopBlock]
				ifFalse: [startBlock _  stopBlock.
						pivotBlock _ startBlock].
			self closeTypeIn].
	self storeSelectionInParagraph! !


