'From Squeak 2.5 of August 6, 1999 on 14 September 1999 at 2:47:15 pm'!

!HandMorph methodsFor: 'world menu' stamp: 'tk 9/14/1999 14:42'!
debugMenu
	"Build the scripting menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'debug...') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'inspect world' target: owner action: #inspect.
	menu add: 'explore world' target: owner action: #explore.
	menu add: 'inspect model' action: #inspectWorldModel.
	menu add: 'start MessageTally' action: #startMessageTally.
	menu addLine.
	"(self hasProperty: #errorOnDraw) ifTrue:  Later make this come up when needed."
		menu add: 'start drawing again' action: #resumeAfterDrawError.
		menu add: 'start stepping again' action: #resumeAfterStepError.
	menu addLine.
	menu add: 'call #tempCommand' action: #callTempCommand.
	menu add: 'define #tempCommand' action: #defineTempCommand.
	^ menu
! !


!SketchEditorMorph methodsFor: 'start & finish' stamp: 'tk 9/14/1999 14:47'!
dimTheWindow
	"Do not call twice!! Installs a morph with an 'onion-skinned' copy of the pixels behind me."

	| dim screen whiteWord |
	"create an 'onion-skinned' version of the stuff on the screen"
	owner outermostMorphThat: [:morph | morph resumeAfterStepError. false].
		"Clear flags that draw orange rect if was ever an error"
	dim _ owner imageFormForRectangle: self bounds.
	screen _ Color pixelScreenForDepth: dim depth.
	dim depth > 1 ifTrue: [
		whiteWord _ Color white pixelWordForDepth: dim depth.
		screen _ screen collect: [:screenWord | screenWord bitAnd: whiteWord]].
	dim fill: dim boundingBox
		rule: (dim depth = 1 ifTrue: [Form and] ifFalse: [Form paint])
		fillColor: screen.
	dimForm _ SketchMorph new form: dim.
	dimForm position: self position.
	owner
		privateAddMorph: dimForm
		atIndex: (owner submorphs indexOf: self) + 1.
! !


!TTGlyph methodsFor: 'printing' stamp: 'tk 9/13/1999 09:54'!
printOn: aStream

	aStream
		nextPutAll: self class name;
		nextPut:$(;
		print: (contours ifNil: [0] ifNotNil: [contours size]);
		nextPut:$).! !
