'From Squeak 2.5 of August 6, 1999 [latest update: #1548] on 15 October 1999 at 2:41:19 pm'!
"Change Set:		FasterCollapse
Date:			15 October 1999
Author:			Bob Arning

In order to speed up the collapsing of SystemWindows (which can be quite tiresome on slow machines and when the window contains a pane with lots of text), do not send #setBoundsOfPaneMorphs to collapsed windows."!


!SystemWindow methodsFor: 'geometry' stamp: 'RAA 10/15/1999 13:54'!
extent: newExtent
	| inner labelRect |
	isCollapsed
		ifTrue: [super extent: newExtent x @ (self labelHeight + 2)]
		ifFalse: [super extent: newExtent].
	inner _ self innerBounds.
	labelRect _ self labelRect.

	stripes first bounds: (labelRect insetBy: 1).
	stripes second bounds: (labelRect insetBy: 3).
	self setStripeColorsFrom: self paneColor.
	closeBox ifNotNil:
		[closeBox align: closeBox topLeft with: inner topLeft + (4@0)].
	menuBox ifNotNil:
		[menuBox align: menuBox topLeft with: (inner topLeft + (19@1))].
	collapseBox align: collapseBox topRight with: inner topRight - (4@0).
	label fitContents; setWidth: (label width min: bounds width - self labelWidgetAllowance).
	label align: label bounds topCenter with: inner topCenter.
	isCollapsed ifTrue: [
		collapsedFrame _ self bounds
	] ifFalse: [
		self setBoundsOfPaneMorphs.
		fullFrame _ self bounds
	].
! !