'From Squeak2.6 of 11 October 1999 [latest update: #1564] on 21 October 1999 at 11:27:32 am'!
"Change Set:		quickFix-sw
Date:			21 October 1999
Author:			Scott Wallace

One quick fix to the smartUpdating code"!


!PluggableMessageCategoryListMorph commentStamp: 'sw 10/21/1999 11:04' prior: 0!
A variant of PluggableListMorph designed specially for efficient handling of the --all-- feature in message-list panes.  In order to be able *quickly* to check whether there has been an external change to the list, we cache the raw list for identity comparison (the actual list is a combination of the --all-- element and the the actual list).!

!PluggableMessageCategoryListMorph methodsFor: 'as yet unclassified' stamp: 'sw 10/21/1999 11:12'!
verifyContents
	
	| newList existingSelection anIndex newRawList |
	(model editSelection == #editComment) ifTrue: [^ self].
	model classListIndex = 0 ifTrue: [^ self].
	newRawList _ model perform: getRawListSelector.
	newRawList == priorRawList ifTrue: [^ self].  "The usual case; very fast"
	priorRawList _ newRawList.
	newList _ (Array with: ClassOrganizer allCategory), priorRawList.
	list = newList ifTrue: [^ self].
	self flash.  "could get annoying, but hell"
	existingSelection _ selection.
	self list: newList.
	(anIndex _ newList indexOf: existingSelection ifAbsent: [nil])
		ifNotNil:
			[self changeModelSelection: anIndex]
		ifNil:
			[self changeModelSelection: 0]! !


