'From Squeak2.7alpha of 19 November 1999 [latest update: #1617] on 21 November 1999 at 12:52:46 am'!

!Browser methodsFor: 'class functions' stamp: 'dwh 11/20/1999 23:22'!
classListMenu: aMenu

^ aMenu labels: 
'browse class
browse full (b)
printOut
fileOut
hierarchy
definition
comment
spawn hierarchy
spawn protocol
inst var refs...
inst var defs...
class var refs...
class vars
class refs (N)
rename...
remove
unsent methods
find method...
fetch documentation' 
	lines: #(4 7 9 11 14 16)
	selections:
		#(buildClassBrowser browseMethodFull printOutClass fileOutClass
		hierarchy editClass editComment
		spawnHierarchy spawnProtocol
		browseInstVarRefs browseInstVarDefs browseClassVarRefs 
		browseClassVariables browseClassRefs
		renameClass removeClass browseUnusedMethods findMethod
		fetchClassDocPane)
! !


!Celeste methodsFor: 'sending mail' stamp: 'dwh 11/20/1999 23:31'!
openSenderInMorphic: initialText
	"open an interface for sending a mail message with the given initial text"
	| textHolder win textMorph buttonsList sendButton |
	textHolder _ StringHolder new.
	textHolder contents: initialText.

	win _ SystemWindow labelled: 'Mister Postman'.
	
	textMorph _ PluggableTextMorph on: textHolder text: #contents  accept: #acceptContents:.
	win addMorph: textMorph  frame: (0@0.1 corner: 1@1).

	buttonsList _ AlignmentMorph newRow.

	sendButton _ PluggableButtonMorph on: [
			textMorph hasUnacceptedEdits ifTrue: [ textMorph accept ].
			self queueMessageWithText: textHolder contents.
			win delete. ]
		getState: nil
		action: #value.
	sendButton label: 'send message'.
	sendButton onColor: Color white  offColor: Color white.
	buttonsList addMorphBack: sendButton.
	
	win addMorph: buttonsList  frame: (0@0 extent: 1@0.1).

	win openInMVC.! !


!Class methodsFor: 'subclass creation' stamp: 'dwh 11/20/1999 23:44'!
weakSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver) in which the subclass is to 
	have weak indexable pointer variables."
	^(ClassBuilder new)
		superclass: self
		weakSubclass: t
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !


!CustomMenu commentStamp: 'dwh 11/20/1999 23:28' prior: 0!
I am used to build menus on-the-fly. I maintain lists of menu items, actions (usually symbols to be sent as messages), and menu section dividing lines to which my clients may append new entries and lines by sending me the messages:

	add: aString action: anAction
	addLine

After the menu is constructed, it may be invoked with one of the following messages:

	startUp: initialSelection
	startUp

I am a subclass of ActionMenu, so I inherit a number of instance variables. The ones I am particularly concerned with are:

	items _ an OrderedCollection of strings to appear in the menu
	selectors _ an OrderedCollection of Symbols to be used as message selectors
	lineArray _ an OrderedCollection of line positions
	lastLine _ used to keep track of the last line to avoid making duplicate entries in lineArray!

