'From Squeak2.6 of 13 October 1999 [latest update: #1733] on 27 December 1999 at 3:31:09 pm'!
"Change Set:		CompressionPostFix-ar
Date:			27 December 1999
Author:			Andreas Raab

A fix for a compression fix in the last change set, e.g., a post-fix ;-)" !


!InflateStream methodsFor: 'private' stamp: 'ar 12/27/1999 15:25'!
pastEndRead
	"A client has attempted to read beyond the read limit.
	Check in what state we currently are and perform
	the appropriate action"
	| blockType |
	state = StateNoMoreData ifTrue:[^nil]. "Get out early if possible"
	"Check if we can move decoded data to front"
	self moveContentsToFront.
	"Check if we can fetch more source data"
	self moveSourceToFront.
	state = StateNewBlock ifTrue:[state _ self getNextBlock].
	blockType _ state bitShift: -1.
	self perform: (BlockTypes at: blockType+1).
	^self next! !


