'From Squeak2.8alpha of 4 February 2000 [latest update: #2310] on 12 June 2000 at 1:00:02 pm'!
"Change Set:		135ScrollBarFix-kfr
Date:			8 June 2000
Author:			Karl Ramberg

When inboard scrollbars and hidden scrollbars are selected two problems
ocured:

1 Problems with text extent in pluggableTextyMorph.
2 Scamper would crash on stratup.

I hope this fixes both :-)"!


!PluggableTextMorph methodsFor: 'geometry' stamp: 'kfr 6/8/2000 22:38'!
resetExtent
	"Reset the extent while maintaining the current selection.  Needed when resizing while the editor is active (when inside the pane)."
	| tempSelection |
	textMorph notNil ifTrue:
		["the current selection gets munged by resetting the extent, so store it"
		tempSelection _ self selectionInterval.
		
		"don't reset it if it's not active"
		tempSelection = (Interval from: 1 to: 0) 
						ifTrue: [retractableScrollBar
							ifTrue:[ ^ self]].
		self extent: self extent.
		self setSelection: tempSelection]! !


!WebPageMorph methodsFor: 'updating' stamp: 'kfr 6/8/2000 20:57'!
update: aSymbol
	| symbol |
	symbol _ aSymbol.
	symbol == nil
		ifTrue:[ symbol _ Color white]. 
	
	super update: symbol.

	aSymbol == getBgSelector ifTrue:
		[ (self isImage: self getBg) ifTrue:[image _ self drawImage: self getBg]
								ifFalse:[ image _ nil.
										self color: self getBg]]! !

