'From Squeak2.9alpha of 26 July 2000 [latest update: #2566] on 5 September 2000 at 8:11:25 am'!
"Change Set:		colorFix-sw
Date:			5 September 2000
Author:			Scott Wallace

Makes undo work for color changes even when the fillStyle property, rather than the color slot, are used to hold the color.

Also fixes the bug that attempts to change gradient colors brought up debuggers because the FillStyles didn't understand the refineXXX messages."!


!FillStyle methodsFor: 'command' stamp: 'sw 9/5/2000 08:08'!
refineRedoTarget: target selector: aSymbol arguments: arguments in: refineBlock
	"Any object can override this method to refine its redo specification"

	^ refineBlock value: target value: aSymbol value: arguments! !

!FillStyle methodsFor: 'command' stamp: 'sw 9/5/2000 08:07'!
refineUndoTarget: target selector: aSymbol arguments: arguments in: refineBlock
	"Any object can override this method to refine its undo specification"

	^ refineBlock value: target value: aSymbol value: arguments! !


!Morph methodsFor: 'menus' stamp: 'sw 9/5/2000 07:35'!
changeColor
	"Change the color of the receiver -- triggered, e.g. from a menu"

	ColorPickerMorph new
		sourceHand: self activeHand;
		target: self;
		selector: #fillStyle:;
		originalColor: self color;
		putUpFor: self near: self fullBoundsInWorld! !

