'From Squeak2.9alpha of 13 June 2000 [latest update: #2558] on 3 September 2000 at 3:44:21 pm'!
"Change Set:		023-BrowserAlphabet-SqR
Date:			3 September 2000
Author:		Andres Valloud	  

This alphabetizer puts the categories starting with 'private' at the
end. The private message categories are also alphabetized on their own."!


!Browser methodsFor: 'message category functions' stamp: 'SqR 7/11/2000 20:36'!
alphabetizeMessageCategories
	| categories privateCategories publicCategories newCategories |

	classListIndex = 0 ifTrue: [^ false].
	self okToChange ifFalse: [^ false].
	Smalltalk changes reorganizeClass: self selectedClassOrMetaClass.

	categories _ self rawMessageCategoryList.
	privateCategories _ categories select:
		[:theOnes | (theOnes findString: 'private' startingAt: 1 caseSensitive: false) = 1].
	publicCategories _ categories copyWithoutAll: privateCategories.
	newCategories _ publicCategories asSortedCollection asOrderedCollection
		addAll: privateCategories asSortedCollection;
		yourself.

	self classOrMetaClassOrganizer categories: newCategories asArray.
	self clearUserEditFlag.
	self editClass.
	self classListIndex: classListIndex.
	^ true! !


!Browser reorganize!
('accessing' contents contents:notifying: contentsSelection couldBrowseAnyClass doItReceiver editSelection noteSelectionIndex:for: request:initialAnswer: spawn:)
('class functions' buildClassBrowser buildClassBrowserEditString: classListMenu: copyClass defineClass:notifying: editClass editComment explainSpecial: fetchClassDocPane fileOutClass findMethod hierarchy makeNewSubclass plusButtonHit printOutClass removeClass renameClass)
('class list' classList classListIndex classListIndex: classListSingleton recent selectClass: selectedClass selectedClassName toggleClassListIndex:)
('code pane' compileMessage:notifying: showBytecodes)
('copying' veryDeepInner:)
('drag and drop' acceptDroppingMorph:event:inMorph: acceptMethod:dstMessageCategory:srcMessageCategory:dstClass:dstClassOrMeta:srcClassOrMeta:internal:copySemantic: acceptMethod:messageCategory:class:atListMorph:internal:copy: changeCategoryForClass:srcSystemCategory:atListMorph:internal:copy: changeMessageCategoryForMethod:dstMessageCategory:srcMessageCategory:insideClassOrMeta:internal:copySemantic: codeTextMorph dragAnimationFor:transferMorph: dragPassengerFor:inMorph: dragTransferTypeForMorph: dstCategoryDstListMorph: dstClassDstListMorph: dstMessageCategoryDstListMorph: message:compileInClass:fromClass:dstMessageCategory:srcMessageCategory:internal:copySemantic: overwriteDialogHierarchyChange:higher:sourceClassName:destinationClassName:methodSelector: wantsDroppedMorph:event:inMorph:)
('initialize-release' browserWindowActivated buildClassSwitchView buildCommentSwitchView buildInstanceClassSwitchView buildInstanceSwitchView buildMorphicSwitches buildOptionalButtonsView defaultBrowserTitle methodCategoryChanged openAsMorphClassEditing: openAsMorphEditing: openAsMorphMessageEditing: openAsMorphMsgCatEditing: openAsMorphSysCatEditing: openEditString: openMessageCatEditString: openMessageEditString: openOnClassWithEditString: openSystemCatEditString: optionalAnnotationHeight optionalButtonHeight optionalButtonPairs optionalButtonRow setClass:selector: setSelector: systemCatSingletonKey:from: systemOrganizer:)
('message category functions' addCategory alphabetizeMessageCategories buildMessageCategoryBrowser buildMessageCategoryBrowserEditString: changeMessageCategories: editMessageCategories fileOutMessageCategories messageCategoryMenu: printOutMessageCategories removeEmptyCategories removeMessageCategory renameCategory)
('message category list' categoryOfCurrentMethod messageCatListSingleton messageCategoryList messageCategoryListIndex messageCategoryListIndex: messageCategoryListSelection rawMessageCategoryList selectMessageCategoryNamed: selectOriginalCategoryForCurrentMethod selectedMessageCategoryName setOriginalCategoryIndexForCurrentMethod toggleMessageCategoryListIndex:)
('message functions' browseImplementors buildMessageBrowser buildMessageBrowserEditString: defineMessage:notifying: defineMessageFrom:notifying: inspectInstances inspectSubInstances messageListMenu:shifted: removeMessage removeMessageFromBrowser)
('message list' messageList messageListIndex messageListIndex: messageListSingleton selectedMessage selectedMessageName toggleMessageListIndex: validateMessageSource:)
('metaclass' classCommentIndicated classMessagesIndicated classOrMetaClassOrganizer indicateClassMessages indicateInstanceMessages instanceMessagesIndicated metaClassIndicated metaClassIndicated: selectedClassOrMetaClass selectedClassOrMetaClassName setClassOrganizer)
('system category functions' addSystemCategory browseAllClasses buildSystemCategoryBrowser buildSystemCategoryBrowserEditString: changeSystemCategories: classNotFound editSystemCategories fileOutSystemCategory findClass potentialClassNames printOutSystemCategory removeSystemCategory renameSystemCategory systemCatSingletonMenu: systemCategoryMenu: updateSystemCategories)
('system category list' indexIsOne indexIsOne: selectCategoryForClass: selectedEnvironment selectedSystemCategoryName systemCategoryList systemCategoryListIndex systemCategoryListIndex: systemCategorySingleton toggleSystemCategoryListIndex:)
!

