'From Squeak2.9BJ of 22 September 2000 [latest update: #2701] on 25 September 2000 at 8:54:04 am'!
"Change Set:		HeadingFixes
Date:			25 September 2000
Author:			Andreas Raab

The CS prevents the generation of players when you get a halo for a morph. Some (now obsolete) code was still relying on having a player for obtaining the heading which is now handled by morphs themselves."!


!HaloMorph methodsFor: 'private' stamp: 'ar 9/25/2000 08:52'!
directionArrowTipCenterFor: directionArrow
	| alphaRadians arrowVector result |
	alphaRadians _ target heading degreesToRadians.
	arrowVector _ self directionArrowLength * (alphaRadians sin  @ alphaRadians cos negated).
	result _ (directionArrowAnchor + arrowVector - (0 @ 0)) rounded.
	^ result
! !

!HaloMorph methodsFor: 'private' stamp: 'ar 9/25/2000 08:51'!
positionDirectionShaft: aPolygon
	"Position the polygon, and return an array holding the coordinates of the tip and the heading in radians."
	| alphaRadians arrowVector tipLocation |
	"Pretty crude and slow approach at present, but a stake in the ground"
	alphaRadians _ target heading degreesToRadians.
	arrowVector _ self directionArrowLength * (alphaRadians sin  @ alphaRadians cos negated).
	aPolygon setVertices: 
		(Array with: directionArrowAnchor
			with: (tipLocation _ directionArrowAnchor + arrowVector)).
	^ Array with: tipLocation with: alphaRadians
! !

