'From Squeak2.9alpha of 17 July 2000 [latest update: #2898] on 26 October 2000 at 9:49:35 am'!
"Change Set:		projSaveSmall
Date:			26 October 2000
Author:			Bob Arning

Some minor fixes (with more than minor impact) for Project saving and loading

- when saving a project, replace parentProject, previousProject and nextProject with nil so as not to drag extra stuff along. When the project is reloaded, parentProject will be set to the Current project and previous and next will be nil until the project is entered.
- add class conversion method for NewMorphicEvent (which should only be found in internal projects created while Andreas was tinkering under the hod of events."!


!HandMorph methodsFor: 'object fileIn' stamp: 'RAA 10/26/2000 09:43'!
convertbosfcemkemkmmlltdcctthsul0: varDict bosfcemkemkmmltdcctthsul0: smartRefStrm
	"These variables are automatically stored into the new instance #('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'mouseFocus' 'keyboardFocus' 'eventListeners' 'mouseListeners' 'keyboardListeners' 'mouseClickState' 'mouseOverHandler' 'lastMouseEvent' 'targetOffset' 'damageRecorder' 'cacheCanvas' 'cachedCanvasHasHoles' 'temporaryCursor' 'temporaryCursorOffset' 'hasChanged' 'savedPatch' 'userInitials' 'lastEventBuffer').
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

		"These are going away #('lastEvent').  Possibly store their info in another variable?"! !


!Project methodsFor: 'file in/out' stamp: 'raa 10/26/2000 09:35'!
objectForDataStream: refStrm
	| uu dp |
	"I am about to be written on an object file.  Write a path to me in the other system instead."

	"Use a copy with no parent, previous or next to reduce extra stuff copied"
	refStrm project == self ifTrue: [^ self copy setParent: nil].

	(uu _ self url) size > 0 ifTrue: [
		dp _ DiskProxy global: #Project selector: #namedUrl: 
			args: (Array with: uu).
		refStrm replace: self with: dp.
		^ dp].
	^ DiskProxy global: #Project selector: #named: args: (Array with: self name)
! !


!SmartRefStream methodsFor: 'conversion' stamp: 'RAA 10/26/2000 09:43'!
newMorphicEventts0

	^ MorphicEvent! !

