'From Squeak2.9alpha of 12 June 2000 [latest update: #2899] on 26 October 2000 at 2:39:36 pm'!
"Change Set:		ownerChangedRevert
Date:			26 October 2000
Author:			Dan Ingalls

Simply reverts the effect of Update 'LayoutChangedOpt' (internal #2694), which had caused run-around text to fail whenever the text's owner was a PastUpMorph.  A future update, with time for a little testing, will offer a better solution to broadcasting ownerChanged downward when and only when required."!


!PasteUpMorph methodsFor: 'layout' stamp: 'tk 10/22/1998 13:55'!
layoutChanged

	super layoutChanged.
	(self valueOfProperty: #SqueakPage) ifNotNil: [
		self setProperty: #pageDirty toValue: true].
		"I am the morph of a SqueakPage, I have changed and 
		need to be written out again"
! !

!PasteUpMorph methodsFor: 'world state' stamp: 'RAA 6/20/2000 12:42'!
extent: aPoint

	super extent: aPoint.
	worldState ifNotNil: [
		worldState viewBox ifNotNil: [
			worldState canvas: nil.
			worldState viewBox: bounds
		].
	].! !

