'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 12 November 2000 at 5:51:50 pm'!
"Change Set:		244NewSymbolTable6-sqr
Date:			30 August 2000
Author:			Andres Valloud

Removes old symbol tables (and the system keeps working after that).

Added Symbol>>compactSymbolTables. Utility method that will crunch the symbol tables to a barely acceptable size"!

String variableByteSubclass: #Symbol
	instanceVariableNames: ''
	classVariableNames: 'SymbolTable '
	poolDictionaries: ''
	category: 'Collections-Text'!

!Symbol class methodsFor: 'class initialization' stamp: 'SqR 8/30/2000 13:59'!
compactSymbolTable
	"Reduce the size of the symbol table so
	that it holds all existing symbols + 1000"

	| oldSize |

	Smalltalk garbageCollect.
	oldSize _ SymbolTable array size.
	SymbolTable growTo: SymbolTable slowSize + 1000.
	^(oldSize - SymbolTable array size) printString, ' slot(s) reclaimed'! !

"Postscript:
Compact the symbol table"

Transcript 
	cr; show: 'Several symbol tables removed.';
	cr; show: Symbol compactSymbolTable!

