'From Squeak2.9alpha of 5 August 2000 [latest update: #3187] on 28 December 2000 at 8:46:45 am'!
"Change Set:		unsentTweak-sw
Date:			28 December 2000
Author:			Scott Wallace

Tweaks 'check for unsent messages' so that selectors for deleted methods are excluded from the check"!


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'sw 12/14/2000 10:59'!
checkForUnsentMessages
	"Check the change set for unsent messages, and if any are found, open up a message-list browser on them"

	| nameLine allChangedSelectors augList unsent messageList |
	nameLine _ '"', self name, '"'.
	allChangedSelectors _ Set new.
	(augList _ self changedMessageListAugmented) do:
		[:aChange |
			MessageSet parse: aChange toClassAndSelector: [:cls :sel | (cls notNil and:
				[cls includesSelector: sel]) ifTrue: [allChangedSelectors add: sel]]].

	unsent _ Smalltalk allUnSentMessagesIn: allChangedSelectors.
	unsent size = 0
		ifTrue:
			[self inform: 'There are no unsent 
messages in change set
', nameLine]
		ifFalse:
			[messageList _ augList select:
				[:aChange |
					MessageSet parse: aChange toClassAndSelector:
						[:cls :sel | unsent includes: sel]].

			Smalltalk browseMessageList: messageList name: 'Unsent messages in ', nameLine]
! !

