'From Squeak2.9alpha of 5 August 2000 [latest update: #3226] on 4 January 2001 at 6:07:37 pm'!
"Change Set:		inherBtnTweaks-sw
Date:			4 January 2001
Author:			Scott Wallace

Update the 'inheritance' button color when class, instance, or ? buttons are pressed in a browser."!


!Browser methodsFor: 'class functions' stamp: 'sw 1/4/2001 18:01'!
plusButtonHit
	"Cycle between definition, comment, and hierachy"

	editSelection == #editComment
		ifTrue: [self hierarchy. ^ self].
	editSelection == #hierarchy
		ifTrue: [editSelection := #editClass.
			classListIndex = 0 ifTrue: [^ self].
			self okToChange ifFalse: [^ self].
			self changed: #editComment.
			self contentsChanged.
			^self].
	classListIndex = 0 ifTrue: [^ self].
	self okToChange ifFalse: [^ self].
	self messageCategoryListIndex: 0.
	editSelection := #editComment.
	self changed: #classSelectionChanged.
	self decorateForInheritance.
	self contentsChanged.! !

!Browser methodsFor: 'metaclass' stamp: 'sw 1/4/2001 18:01'!
metaClassIndicated: trueOrFalse 
	"Indicate whether browsing instance or class messages."

	metaClassIndicated _ trueOrFalse.
	self setClassOrganizer.
	systemCategoryListIndex > 0 ifTrue:
		[editSelection _ classListIndex = 0
			ifTrue: [metaClassIndicated
				ifTrue: [#none]
				ifFalse: [#newClass]]
			ifFalse: [#editClass]].
	messageCategoryListIndex _ 1.
	messageListIndex _ 0.
	contents _ nil.
	self changed: #classSelectionChanged.
	self changed: #messageCategoryList.
	self changed: #messageList.
	self changed: #contents.
	self decorateForInheritance
! !

