'From Squeak3.1alpha of 5 February 2001 [latest update: #4037] on 17 May 2001 at 4:35:56 pm'!
"Change Set:		geeMailOffset
Date:			17 May 2001
Author:			Bob Arning

Fix a problem where morphs dropped in a GeeMail were sometimes moving to the right unexpectedly"!


!TextPlusMorph methodsFor: 'as yet unclassified' stamp: 'RAA 5/17/2001 16:33'!
repositionAnchoredMorphs

	| am cBlock leftShift firstCharacterIndex lastCharacterIndex |

	firstCharacterIndex _ paragraph firstCharacterIndex.
	lastCharacterIndex _ paragraph lastCharacterIndex.
	text runs withStartStopAndValueDo: [:start :stop :attributes |
		attributes do: [:att |
			(att isMemberOf: TextAnchorPlus) ifTrue: [
				am _ att anchoredMorph.
				(am isNil or: [am world isNil]) ifFalse: [
					(stop between: firstCharacterIndex and: lastCharacterIndex) ifTrue: [
						cBlock _ self paragraph characterBlockForIndex: stop.
						leftShift _ am valueOfProperty: #geeMailLeftOffset ifAbsent: [0].
						am position: (self left + leftShift) @ cBlock origin y.
					].
				]
			]
		]
	].
! !

