'From Squeak3.1alpha of 28 February 2001 [latest update: #4122] on 4 June 2001 at 12:43:02 am'!
"Change Set:		ButtonFillStyles-ar
Date:			4 June 2001
Author:			Andreas Raab

Enable the use of fill styles in buttons."!


!FillStyle methodsFor: 'converting' stamp: 'ar 6/4/2001 00:41'!
mixed: fraction with: aColor
	^self asColor mixed: fraction with: aColor! !


!GradientFillStyle methodsFor: 'converting' stamp: 'ar 6/4/2001 00:42'!
mixed: fraction with: aColor
	^self copy colorRamp: (colorRamp collect:[:assoc| assoc key -> (assoc value mixed: fraction with: aColor)])! !


!Morph methodsFor: 'accessing' stamp: 'ar 6/4/2001 00:39'!
color: aColor
	color isColor ifFalse:[^self fillStyle: aColor].
	color = aColor ifFalse: [
		self removeProperty: #fillStyle.
		color _ aColor.
		self changed].
! !


!SimpleButtonMorph methodsFor: 'events' stamp: 'ar 6/4/2001 00:39'!
mouseDown: evt

	| now dt |
	now _ Time millisecondClockValue.
	oldColor _ self fillStyle. 
	actWhen == #buttonDown
		ifTrue: [self doButtonAction]
		ifFalse: [	self updateVisualState: evt; refreshWorld].
	dt _ Time millisecondClockValue - now max: 0.  "Time it took to do"
	dt < 200 ifTrue: [(Delay forMilliseconds: 200-dt) wait].
	self mouseStillDown: evt.! !


!ChatButtonMorph methodsFor: 'events' stamp: 'ar 6/4/2001 00:40'!
mouseDown: evt

	oldColor _ self fillStyle.
	self label: labelDown.
	self doButtonDownAction.

! !


!SimpleSwitchMorph methodsFor: 'as yet unclassified' stamp: 'ar 6/4/2001 00:39'!
mouseDown: evt

	oldColor _ self fillStyle.! !

