'From Squeak3.1alpha of 28 February 2001 [latest update: #4252] on 16 August 2001 at 4:27:10 pm'!
"Change Set:		AltWindowFix-ar
Date:			16 August 2001
Author:			Andreas Raab

Two small fixes for better compatibility between the old and alt window regime."!


!SystemWindow methodsFor: 'label' stamp: 'ar 8/16/2001 16:25'!
setStripeColorsFrom: paneColor
	"Set the stripe color based on the given paneColor"
	labelArea ifNotNil:[
		Preferences alternativeWindowLook 
			ifTrue:[labelArea color: paneColor lighter]
			ifFalse:[labelArea color: Color transparent]].
	stripes ifNil: [^ self].
	Preferences alternativeWindowLook ifFalse:[
		self isActive
			ifTrue: [stripes second color: paneColor;
						borderColor: stripes second color darker.
					stripes first color: stripes second borderColor darker;
						borderColor: stripes first color darker]
			ifFalse: ["This could be much faster"
					stripes second color: paneColor; borderColor: paneColor.
					stripes first color: paneColor; borderColor: paneColor].
	] ifTrue:[
		self isActive
			ifTrue: [stripes first borderColor: paneColor lighter;
						color: stripes first borderColor.
					stripes second borderColor: stripes first color lighter;
						color: stripes second borderColor]
			ifFalse: ["This could be much faster"
					stripes second color: paneColor; borderColor: paneColor.
					stripes first color: paneColor; borderColor: paneColor].
	].! !

"Postscript:
Fix up some old windows."
| cc |
SystemWindow allInstancesDo:[:sw|
	((cc _ sw paneMorphs first color) = Color transparent) ifFalse:[
		sw paneColor: cc; setStripeColorsFrom: cc.
	].
].!

