'From Squeak3.2alpha of 8 October 2001 [latest update: #4554] on 27 November 2001 at 12:05:26 pm'!
"Change Set:		noAudioDir
Date:			27 November 2001
Author:			Michael Rueger

The 'audio' dir for ChatNotes is now only created if really needed."!


!ChatNotes methodsFor: 'initialization' stamp: 'mir 11/27/2001 12:01'!
loadNotes
	"Load notes from the files"
	| dir |

	names _ OrderedCollection new.
	notes _ OrderedCollection new.
	(FileDirectory default directoryExists: 'audio')
		ifFalse: [^self].
	dir _ self audioDirectory.
	dir fileNames do: [:fname |
		(fname endsWith: '.name') ifTrue: [
			names add: ((dir fileNamed: fname) contentsOfEntireFile).
			notes add: (fname copyFrom: 1 to: (fname size - 4))]].! !

!ChatNotes methodsFor: 'file i/o' stamp: 'mir 11/27/2001 12:04'!
audioDirectory

	(FileDirectory default directoryExists: 'audio')
		ifFalse: [FileDirectory default createDirectory: 'audio'].
	^FileDirectory default directoryNamed: 'audio'! !

