'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 3 March 2002 at 3:45:43 pm'!
"Change Set:		scrollBarAgain-dew
Date:			3 March 2002
Author:			Doug Way

Reverts the 4722fixScrollbarOnRight update, since that caused problems with morph lists being reordered and windows coming to front when they shouldn't.  This reimplements support for displaying flop-out scrollbars on the right by reordering the pane morphs in the SystemWindow, during window creation."!


!ScrollPane methodsFor: 'scrolling' stamp: 'RAA 12/18/2000 17:15'!
showScrollBar
	(submorphs includes: scrollBar) ifTrue: [^ self].
	self resizeScrollBar.
	self privateAddMorph: scrollBar atIndex: 1.
	"scrollBar changed."
	retractableScrollBar ifFalse: [self resetExtent]! !


!SystemWindow methodsFor: 'panes' stamp: 'dew 3/3/2002 12:36'!
addMorph: aMorph fullFrame: aLayoutFrame

	super addMorph: aMorph fullFrame: aLayoutFrame.

	paneMorphs _ paneMorphs copyReplaceFrom: 1 to: 0 with: (Array with: aMorph).
	Preferences alternativeWindowLook
		ifFalse:
			[aMorph borderWidth: 1.
			aMorph color: self paneColor]
		ifTrue:
			[aMorph adoptPaneColor: self paneColor.
			aMorph borderWidth: 2; borderColor: #inset; color: Color transparent].
	Preferences scrollBarsOnRight	"reorder panes so flop-out right-side scrollbar is visible"
		ifTrue: [self addMorphBack: aMorph]! !