'From Squeak 2.3 beta of Nov 25, 1998 on 15 December 1998 at 9:26:48 pm'!
"Change Set:		CmdVinMsgLists
Date:			15 December 1998
Author:			Dan Ingalls

Adds cmd-v for versions to the cmd-key options in message lists.
"!


!StringHolder methodsFor: 'message list menu' stamp: 'di 12/15/1998 21:25'!
messageListKey: aChar from: view
	"Respond to a Command key.  I am a model with a code pane, and I also have a listView that has a list of methods.  The view knows how to get the list and selection."
	| sel class |
	(sel _ self selectedMessageName) ifNil: [^ self arrowKey: aChar from: view].
	aChar == $m ifTrue: [^ Smalltalk browseAllImplementorsOf: sel].
	aChar == $n ifTrue: [^ Smalltalk browseAllCallsOn: sel].
	aChar == $b ifTrue: [^ (class _ self selectedClass) ifNotNil:
							[Browser fullOnClass: class selector: sel]].
	aChar == $v ifTrue: [^ self browseVersions].
	^ self arrowKey: aChar from: view! !


