'From Squeak3.3alpha of 18 January 2002 [latest update: #4934] on 31 July 2002 at 4:03:40 pm'!
"Change Set:		soundTileFix-sw
Date:			31 July 2002
Author:			Scott Wallace

Sound tiles created with the SoundRecorder will again be well-formed.  They had gotten broken somewhere along the way."!


!RecordingControlsMorph methodsFor: 'button commands' stamp: 'sw 7/31/2002 16:03'!
makeTile
	"Make a tile representing my sound.  Get a sound-name from the user by which the sound is to be known"

	| newStyleTile sndName tile |
	recorder pause.
	newStyleTile _ true.
	newStyleTile
		ifTrue:
			[sndName _ FillInTheBlank
				request: 'Please enter a name this sound'
				initialAnswer: 'sound'.
			sndName isEmpty ifTrue: [^ self].

			sndName _ SampledSound unusedSoundNameLike: sndName.
			SampledSound
				addLibrarySoundNamed: sndName
				samples: recorder condensedSamples
				samplingRate: recorder samplingRate.
			tile _ SoundTile new literal: sndName]
		ifFalse:
			[tile _ InterimSoundMorph new sound: 
				(SampledSound
					samples: recorder condensedSamples
					samplingRate: recorder samplingRate)].

	tile bounds: tile fullBounds.
	tile openInHand! !

