'From Squeak 2.3 of January 14, 1999 on 10 March 1999 at 1:23:51 pm'!
"Change Set:		flapInit-sw
Date:			10 March 1999
Author:			Scott Wallace

Theoretically cures the wrong-size problem in bootstrapping the use of flaps"!


!FlapTab methodsFor: 'solid tabs' stamp: 'sw 3/10/1999 12:10'!
spanWorld
	| aPoint |
	aPoint _ (self world ifNil: [self currentWorld]) extent.
	(self orientation == #vertical)
		ifTrue:
			[referent height: aPoint y]
		ifFalse:
			[referent width: aPoint x] ! !


!PasteUpMorph methodsFor: 'flaps' stamp: 'sw 3/10/1999 13:21'!
addGlobalFlaps
	"Normally, like all the flap stuff, intended for use only in a World -- but the code for flaps generally put into PasteUpMorph for possible more general use in future

	Utilities clobberFlapTabList.
	Utilities initializeStandardFlaps.
	self currentWorld deleteAllFlapArtifacts.
	self currentWorld addGlobalFlaps.

"
	| flapList |

	(Preferences valueOfFlag: #useGlobalFlaps) ifFalse: [^ self].
	Smalltalk isMorphic ifFalse: [^ self].
	
	flapList _ Utilities globalFlapTabs.
	flapList do:
		[:aFlapTab |
			(aFlapTab world == self) ifFalse:
				[self addMorphFront: aFlapTab.
				aFlapTab adaptToWorld: self].
			aFlapTab spanWorld.
			aFlapTab adjustPositionAfterHidingFlap.
			aFlapTab flapShowing ifTrue: [aFlapTab showFlap]]! !


