'From Squeak3.1alpha of 5 February 2001 [latest update: #3553] on 9 February 2001 at 5:22:53 pm'!
"Change Set:		fasterBrowsers
Date:			9 February 2001
Author:			Bob Arning

Speed up browser opening by setting #highlightSelector before the list selector is set, thus avoiding double list initialization"!


!Browser methodsFor: 'initialize-release' stamp: 'RAA 2/9/2001 16:36'!
buildMorphicClassList

	| myClassList |

	(myClassList _ PluggableListMorph new) 
			setProperty: #highlightSelector toValue: #highlightClassList:with:;

			on: self list: #classList
			selected: #classListIndex changeSelected: #classListIndex:
			menu: #classListMenu:shifted: keystroke: #classListKey:from:.
	myClassList borderWidth: 0.
	myClassList enableDragNDrop: Preferences browseWithDragNDrop.
	^myClassList

! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 2/9/2001 16:37'!
buildMorphicMessageCatList

	| myMessageCatList |

	(myMessageCatList _ PluggableMessageCategoryListMorph new) 
			setProperty: #highlightSelector toValue: #highlightMessageCategoryList:with:;

			on: self list: #messageCategoryList
			selected: #messageCategoryListIndex changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu: 
			keystroke: #arrowKey:from: getRawListSelector: #rawMessageCategoryList.
	myMessageCatList enableDragNDrop: Preferences browseWithDragNDrop.
	^myMessageCatList
! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 2/9/2001 16:35'!
buildMorphicMessageList

	| aListMorph |

	(aListMorph _ PluggableListMorph new) 
			setProperty: #highlightSelector toValue: #highlightMessageList:with:;

			on: self list: #messageList
			selected: #messageListIndex changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	aListMorph enableDragNDrop: Preferences browseWithDragNDrop.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	^aListMorph

! !

!Browser methodsFor: 'initialize-release' stamp: 'RAA 2/9/2001 16:34'!
buildMorphicSystemCatList
	| dragNDropFlag myCatList |
	dragNDropFlag _ Preferences browseWithDragNDrop.
	(myCatList _ PluggableListMorph new) 
			setProperty: #highlightSelector toValue: #highlightSystemCategoryList:with:;

			on: self list: #systemCategoryList
			selected: #systemCategoryListIndex changeSelected: #systemCategoryListIndex:
			menu: #systemCategoryMenu: keystroke: #systemCatListKey:from:.
	myCatList enableDragNDrop: dragNDropFlag.
	^myCatList
! !

