'From Squeak3.1alpha of 5 February 2001 [latest update: #3874] on 22 March 2001 at 1:00:42 pm'!
"Change Set:		navMenuTweak
Date:			22 March 2001
Author:			Bob Arning

minor menu change to make things a bit clearer"!


!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 3/22/2001 12:59'!
moreCommands

	| allThreads aMenu others target |

	allThreads _ self class knownThreads.
	aMenu _ MenuMorph new defaultTarget: self.
	others _ (allThreads keys reject: [ :each | each = threadName]) asSortedCollection.
	others do: [ :each |
		aMenu add: 'switch to <',each,'>' selector: #switchToThread: argument: each.
	].
	aMenu 
		add: 'switch to recent projects' action: #getRecentThread;
		addLine;
		add: 'create a new thread' action: #threadOfNoProjects;
		add: 'edit this thread' action: #editThisThread;
		add: 'create thread of all projects' action: #threadOfAllProjects;
		addLine;
		add: 'First project in thread' action: #firstPage;
		add: 'Last project in thread' action: #lastPage.
	(target _ self currentIndex + 2) > listOfPages size ifFalse: [
		aMenu 
			add: 'skip over next project (',(listOfPages at: target - 1) first,')' 
			action: #skipOverNext
	].
	aMenu
		add: 'jump within this thread' action: #jumpWithinThread;
		add: 'insert new project' action: #insertNewProject;
		addLine;
		add: 'simply close this navigator' action: #delete;
		add: 'destroy this thread' action: #destroyThread.

	aMenu popUpEvent: self world primaryHand lastEvent in: self world! !

