'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 30 April 2001 update 3910] on 30 April 2001 at 6:20:44 pm'!
"Change Set:		BrowserSystemCategoryList
Date:			30 April 2001
Author:			Joern Eyrich

Fixes a problem reported by Scott A Crosby when adding a Category in the Package Browser without having a Category selected.  Changes hardcoded access to category list to use subclass-overridable access method"!


!Browser methodsFor: 'system category functions' stamp: 'je 4/30/2001 17:59'!
addSystemCategory
	"Prompt for a new category name and add it before the
	current selection, or at the end if no current selection"
	| oldIndex newName |
	self okToChange ifFalse: [^ self].
	oldIndex _ systemCategoryListIndex.
	newName _ self
		request: 'Please type new category name'
		initialAnswer: 'Category-Name'.
	newName isEmpty
		ifTrue: [^ self]
		ifFalse: [newName _ newName asSymbol].
	systemOrganizer
		addCategory: newName
		before: (systemCategoryListIndex = 0
				ifTrue: [nil]
				ifFalse: [self selectedSystemCategoryName]).
	self systemCategoryListIndex:
		(oldIndex = 0
			ifTrue: [self systemCategoryList size]
			ifFalse: [oldIndex]).
	self changed: #systemCategoryList.! !

