'From Squeak3.4alpha of 6 November 2002 [latest update: #5109] on 19 November 2002 at 2:50:03 pm'!
"Change Set:		projSaveFixes-sw
Date:			19 November 2002
Author:			Scott Wallace

Addresses problems that were interfering with the ability of projects containing etoy scripts to be successfully saved, and also caused errors in attempting to load saved project files.

(1)  Fixes a serious bug in update 5095Project-dep-tk which would frequently abort project-saving, with an error.
(2)  The Postscript of the update forces recompilation of three classes that had obsolete references to ResourceCollector in them, presumably as a result of the (now-purportedly-fixed) class mutate bugs."!


!ImageSegment methodsFor: 'read/write segment' stamp: 'sw 11/19/2002 14:40'!
dependentsCancel: aProject
	"Erase the place we temporarily held the dependents of things in this project.  So we don't carry them around forever."

	aProject projectParameters removeKey: #GlobalDependentsInProject ifAbsent: []! !

"Postscript:"
Form compileAll.
Project compileAll.
ProjectLoading class compileAll.
!

