'From Squeak3.6beta of ''4 July 2003'' [latest update: #5411] on 4 September 2003 at 7:01:26 pm'!
"Change Set:		FileContentsBrowserFix-mu
Date:			4 September 2003
Author:			Masashi Umezawa

FileContentsBrowser>>selectedClassOrMetaClass should return nil when there is no selection. But the method raises MessageNotUnderstood when the browser indicates metaclass AND selectedClass is nil, because it tries to send #metaClass to nil.

Now the method correctly returns nil in such case.

-To see the problem:
	Open the code browser for codes with class methods only.
	Without any class selection, push the 'class' button in the browser. 

"!


!FileContentsBrowser methodsFor: 'metaclass' stamp: 'mu 9/4/2003 18:11'!
selectedClassOrMetaClass
	"Answer the selected class or metaclass."
	| selectedClass |
	selectedClass _ self selectedClass ifNil:[^nil].
	^self metaClassIndicated
		ifTrue: [selectedClass metaClass]
		ifFalse: [selectedClass]! !

