'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5430] on 16 October 2003 at 10:55:14 pm'!
"Change Set:		DeprecationRename-dew
Date:			7 October 2003
Author:			Doug Way

Renamed the deprecation methods to be less unnecessarily verbose, since they are commonly used.  #deprecatedExplanation: is renamed to #deprecated:, and #deprecated:explanation is renamed to #deprecated:block:.  (The old methods are actually, um, deprecated rather than deleted.)"!


!Object methodsFor: 'error handling' stamp: 'dew 10/6/2003 18:20'!
deprecated: anExplanationString
	"Warn that the sending method has been deprecated."

	Preferences showDeprecationWarnings ifTrue:
		[Deprecation signal: thisContext sender printString, ' has been deprecated. ', anExplanationString]! !

!Object methodsFor: 'error handling' stamp: 'dew 10/7/2003 00:26'!
deprecated: anExplanationString block: aBlock 
	 "Warn that the sender has been deprecated.  Answer the value of aBlock on resumption.  (Note that #deprecated: is usually the preferred method.)"

	Preferences showDeprecationWarnings ifTrue:
		[Deprecation
			signal: thisContext sender printString, ' has been deprecated. ', anExplanationString].
	^ aBlock value.
! !

!Object methodsFor: 'error handling' stamp: 'dew 10/16/2003 00:11'!
deprecated: aBlock explanation: aString 
	"This method is OBSOLETE.  Use #deprecated:block: instead."
	self deprecated: 'Use Object>>deprecated:block: instead of deprecated:explanation:.'.

	Preferences showDeprecationWarnings ifTrue:
		[Deprecation
			signal: thisContext sender printString, ' has been deprecated. ', aString].
	^ aBlock value.
! !

!Object methodsFor: 'error handling' stamp: 'dew 10/16/2003 00:10'!
deprecatedExplanation: aString
	"This method is OBSOLETE.  Use #deprecated: instead."
	self deprecated: 'Use Object>>deprecated: instead of deprecatedExplanation:.'.

	Preferences showDeprecationWarnings ifTrue:
		[Deprecation signal: thisContext sender printString, ' has been deprecated. ', aString]! !

