'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 17 October 2003 at 4:38:15 pm'!
"Change Set:		TextMorphDropShadowInvalidateFix-nk
Date:			17 October 2003
Author:			Ned Konz

This fixes a problem where TextMorphs with drop shadows would leave traces of their selections behind when they lost focus.
"!


!TextMorph methodsFor: 'private' stamp: 'nk 10/17/2003 16:36'!
selectionChanged
	"Invalidate all the selection rectangles. 
	Make sure that any drop shadow is accounted for too."
	self paragraph selectionRects
		do: [:r | self
				invalidRect: (self expandFullBoundsForDropShadow: r)]! !

