'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 14 October 2003 at 1:14:17 pm'!
"Change Set:		BalloonFillFix-nk
Date:			26 September 2003
Author:			Ned Konz

This ensures that the 'span' bitmap used in the BalloonEngine is wide enough to handle the width of the display.

This fixes problems with display widths > 2048.
"!


!BalloonEngine methodsFor: 'initialize' stamp: 'nk 9/26/2003 10:52'!
initialize
	| w |
	w _ Display width > 2048 ifTrue: [ 4096 ] ifFalse: [ 2048 ].
	externals _ OrderedCollection new: 100.
	span _ Bitmap new: w.
	bitBlt _ nil.
	self bitBlt: ((BitBlt toForm: Display) destRect: Display boundingBox; yourself).
	forms _ #().
	deferred _ false.! !

