'From Squeak3.7alpha of ''15 October 2003'' [latest update: #5595] on 12 December 2003 at 3:33:32 pm'!
"Change Set:		MVC-ParEditor
Date:			12 December 2003
Author:			Boris Gaertner

Change set 5500 introduced a lot of interesting improvements to the editing functionality. It works fine in Morphic, but in MVC we see an annoying flaw: When you scroll a longer piece of text, you see two or more carets after scrolling.

This change set is an attempt to fix this. Test reports are of course welcome. "!


!ParagraphEditor methodsFor: 'scrolling' stamp: 'BG 12/12/2003 15:31'!
scrollBy: heightToMove
	"Move the paragraph by heightToMove, and reset the text selection."
	^ paragraph scrollBy: heightToMove withSelectionFrom: self pointBlock to: self markBlock! !

!ParagraphEditor methodsFor: 'current selection' stamp: 'BG 12/12/2003 12:50'!
reverseSelection
	"Reverse the valence of the current selection highlighting."
	selectionShowing _ selectionShowing not.
	paragraph reverseFrom: self pointBlock to: self markBlock! !


