'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 9 February 2004 at 1:48:45 pm'!
"Change Set:		fileOutCategory-asFileName-fix-jf
Date:			7 February 2004
Author:			Julian Fitzell

#fileOutCategory:asHtml: would try to create files without first validating the file names.  This was a problem if you had a system category with a / in it for example.  Fix this by adding a call to #asFileName on the file name string."!


!SystemOrganizer methodsFor: 'fileIn/Out' stamp: 'jf 2/7/2004 17:24'!
fileOutCategory: category asHtml: useHtml
	"FileOut all the classes in the named system category."
	| fileStream |
	fileStream _ useHtml
		ifTrue: [(FileStream newFileNamed: category asFileName, '.html') asHtml]
		ifFalse: [FileStream newFileNamed: category asFileName , '.st'].
	self fileOutCategory: category on: fileStream initializing: true.
	fileStream close! !

