'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 20 February 2004 at 8:12:52 am'!
"Change Set:		acceptCodeFix-bg
Date:			3 February 2004
Author:			Boris Gaertner

KLC - I removed the commented out send in Browser>>selectOriginalCategoryForCurrentMethod otherwise identical.

this change set fixes a bug that was reported on the list at Feb 03, 2004 by arj . A day later arj reported two additional ways to demonstrate undesired behavior of the brower. "!


!Browser methodsFor: 'message category list' stamp: 'BG 2/4/2004 23:26'!
messageCategoryListIndex: anInteger 
	"Set the selected message category to be the one indexed by anInteger."

	messageCategoryListIndex _ anInteger.
	messageListIndex _ 0.
	self changed: #messageCategorySelectionChanged.
	self changed: #messageCategoryListIndex.	"update my selection"
	self changed: #messageList.
	editSelection = #newMessage
	  ifTrue: [^self].
	editSelection _ 
		anInteger <= 0
			ifTrue: [#editClass]
			ifFalse: [#newMessage].
	contents _ nil.

	self contentsChanged
! !

!Browser methodsFor: 'message category list' stamp: 'KLC 2/20/2004 08:08'!
selectOriginalCategoryForCurrentMethod
	"private - Select the message category for the current method. 
	 
	 Note:  This should only be called when somebody tries to save  
	 a method that they are modifying while ALL is selected. 
	 
	 Returns: true on success, false on failure."
	| aSymbol selectorName |
	aSymbol _ self categoryOfCurrentMethod.
	selectorName _ self selectedMessageName.
	(aSymbol notNil and: [aSymbol ~= ClassOrganizer allCategory])
		ifTrue: 
			[messageCategoryListIndex _ (self messageCategoryList indexOf: aSymbol).
			messageListIndex _ (self messageList indexOf: selectorName).
			self changed: #messageCategorySelectionChanged.
			self changed: #messageCategoryListIndex.	"update my selection"
			self changed: #messageList.
			self changed: #messageListIndex.
			^ true].
	^ false! !

