'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 20 February 2004 at 12:30:58 pm'!
"Change Set:		setClassSelectorPackagePane-avi
Date:			21 February 2004
Author:			Avi Bryant

Browser>>setClass:selector: now uses #selectCategoryForClass: so that it works properly from the PackagePaneBrowser as well.

This fixes the bug with out of bounds errors when defining new classes in the PackagePaneBrowser that was caused by update 5487."!


!Browser methodsFor: 'initialize-release' stamp: 'avi 2/21/2004 12:25'!
setClass: aBehavior selector: aSymbol
	"Set the state of a new, uninitialized Browser."

	| isMeta aClass messageCatIndex |
	aBehavior ifNil: [^ self].
	(aBehavior isKindOf: Metaclass)
		ifTrue: [isMeta _ true. aClass _ aBehavior soleInstance]
		ifFalse: [isMeta _ false. aClass _ aBehavior].
	self selectCategoryForClass: aClass.
	self classListIndex:
			((SystemOrganization listAtCategoryNamed: self selectedSystemCategoryName )
					indexOf: aClass name).
	self metaClassIndicated: isMeta.
	aSymbol ifNil: [^ self].
	messageCatIndex _ aBehavior organization numberOfCategoryOfElement: aSymbol.
	self messageCategoryListIndex: messageCatIndex + 1. "<- FIXED offset"
	messageCatIndex = 0 ifTrue: [^ self].
	self messageListIndex:
			((aBehavior organization listAtCategoryNumber: messageCatIndex)
					indexOf: aSymbol)! !

