'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 2 March 2004 at 11:14:46 am'!
"Change Set:		PortNumColonSyntax-gk
Date:			2 March 2004
Author:			Gran Krampe

Adaptation of Andrew Blacks original SMTPSocket fix.
Simple addition to ProtocolClient class>>openOnHostNamed: in order to be able to use the colon syntax to express a portnumber.

Example: 'mail.mydomain.com:25' would use 25 instead of 'self defaultPortNumber' as the port.

(Fixed a potential buglet so that the colon is not included in the port substring. -dew)
"!


!ProtocolClient class methodsFor: 'instance creation' stamp: 'gk 3/2/2004 11:10'!
openOnHostNamed: hostName
	"If the hostname uses the colon syntax to express a certain portnumber
	we use that instead of the default port number."

	| i |
	i _ hostName indexOf: $:.
	i = 0 ifTrue: [
			^self openOnHostNamed: hostName port: self defaultPortNumber]
		ifFalse: [
			| s p | 
			s _ hostName truncateTo: i - 1.
			p _ (hostName copyFrom: i + 1 to: hostName size) asInteger.
			^self openOnHostNamed: s port: p]
	! !

