'From Squeak3.7alpha of 11 September 2003 [latest update: #5765] on 9 March 2004 at 12:40:02 pm'!
"Change Set:		SetDefaultSoundService-nk
Date:			9 March 2004
Author:			Ned Konz

Recent updates have left the default SoundService unset, causing a prompt on the first time a sound occurs.

This CS:
- adds a means to set a default on an AppRegistry subclass
- sets the default sound service to BaseSoundSystem if unset.
This is done in the postscript.

"

!


!AppRegistry class methodsFor: 'as yet unclassified' stamp: 'nk 3/9/2004 12:33'!
default: aClassOrNil
	"Sets my default to aClassOrNil. 
	Answers the old default."
	| oldDefault |
	oldDefault := default.
	aClassOrNil ifNotNil: [ self register: aClassOrNil ].
	default := aClassOrNil.
	^ oldDefault! !

!AppRegistry class methodsFor: 'as yet unclassified' stamp: 'nk 3/9/2004 12:35'!
defaultOrNil
	^ default! !

"Postscript:
Set the SoundService to the BaseSoundSystem if it's unset."

SoundService defaultOrNil ifNil: [
	SoundService default: (SoundService registeredClasses detect: [ :cl | cl isKindOf: BaseSoundSystem] ifNone: [])]!

