'From Squeak3.7gamma of ''17 July 2004'' [latest update: #5976] on 18 July 2004 at 4:16:01 pm'!
"Change Set:		DefaultChangeSetNameFix-nk
Date:			18 July 2004
Author:			Ned Konz

Fixes a problem on the mac where the change set file out doesn't auto-number correctly.
"!


!ChangeSet class methodsFor: 'defaults' stamp: 'nk 7/18/2004 16:13'!
defaultChangeSetDirectory
	"Answer the directory in which to store ChangeSets. 
	Answer the default directory if the preferred directory doesn't exist."
	| dir directoryName |
	directoryName := Preferences
				parameterAt: #defaultChangeSetDirectoryName
				ifAbsentPut: [''].
	dir := directoryName isEmptyOrNil
		ifTrue: [ FileDirectory default ]
		ifFalse: [ FileDirectory default directoryNamed: directoryName ].
	dir exists
		ifTrue: [^ dir].
	^ FileDirectory default! !

