'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5983] on 17 August 2004 at 6:56:16 am'!
"Change Set:		TextMorphExtentFix-nk
Date:			17 August 2004
Author:			Ned Konz

Fixes a long-standing (3.5, 3.6, 3.7, 3.8a) recursion problem in PluggableTextMorph, where we sometimes see:

PluggableTextMorph>>extent:
PluggableTextMorph>>resetExtent
PluggableTextMorph(ScrollPane)>>hideScrollBar
PluggableTextMorph(ScrollPane)>>hideOrShowScrollBar
PluggableTextMorph(ScrollPane)>>setScrollDeltas
PluggableTextMorph>>extent:
PluggableTextMorph>>resetExtent
PluggableTextMorph(ScrollPane)>>showScrollBar
PluggableTextMorph(ScrollPane)>>hideOrShowScrollBar
PluggableTextMorph(ScrollPane)>>setScrollDeltas

"!


!PluggableTextMorph methodsFor: 'geometry' stamp: 'nk 7/11/2004 19:08'!
extent: newExtent

	bounds extent = newExtent ifTrue: [^ self].
	super extent: (newExtent max: 36@16).
	textMorph ifNotNil:
		[textMorph extent: (self innerBounds width-6)@self height].
	self setScrollDeltas
! !

