'From Small-Land 3.8-5976-0266 of 2 September 2004 [latest update: #5976] on 7 September 2004 at 6:36:54 pm'!
"Change Set:		PreferenceBalloonHelpDelayTime-dgd
Date:			7 September 2004
Author:			Diego Gomez Deck

New preference to remove the hardcoded value in Morph>>balloonHelpDelayTime.

The default for the new preference is, as usual, the previous hardcoded value.
"!


!Morph methodsFor: 'halos and balloon help' stamp: 'dgd 9/7/2004 18:35'!
balloonHelpDelayTime
	"Return the number of milliseconds before a balloon help should be put up on the receiver. The balloon help will only be put up if the receiver responds to #wantsBalloon by returning true."
	^ Preferences balloonHelpDelayTime! !


!Preferences class methodsFor: 'misc' stamp: 'dgd 9/7/2004 18:35'!
balloonHelpDelayTime
	"Answer the number of milliseconds before a balloon help 
	should be put up on morphs."
	^ Parameters
		at: #balloonHelpDelayTime
		ifAbsent: [800]! !

