'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #324] on 11 September 2004 at 4:47:12 pm'!
"Change Set:		referencePlayfieldFix-sw
Date:			11 September 2004
Author:			Scott Wallace

Fixes the computation of referencePlayfield that got broken in update 5465.

Version 2 -- the referencePlayfield is now correctly computed even in the case (which formerly was never properly handled) when the grabbed-morph's former owner is flexed.  But the cartesian getX and getY computations in that situation are still wrong, and to be made right they seemingly would need to factor in the former owner's transformation."!


!Morph methodsFor: 'e-toy support' stamp: 'sw 9/11/2004 16:23'!
referencePlayfield
	"Answer the PasteUpMorph to be used for cartesian-coordinate reference"

	| former |
	owner ifNotNil:
		[(self topRendererOrSelf owner isHandMorph and: [(former _ self formerOwner) notNil])
			ifTrue:
				[former _ former renderedMorph.
				^ former isPlayfieldLike 
					ifTrue: [former]
					ifFalse: [former referencePlayfield]]].

	self allOwnersDo: [:o | o isPlayfieldLike ifTrue: [^ o]].
	^ ActiveWorld! !

