'From Squeak3.7beta of ''1 April 2004'' [latest update: #5868] on 1 April 2004 at 10:08:58 pm'!
"Change Set:		ConvertHTTPProxyPort
Date:			1 April 2004
Author:			Yoshiki Ohshima

Fixes a conversion error in HTTPSocket class>>useProxyServerNamed:port:

(Reposted as changeset from a mail of Yoshiki Ohshima -- laza)"!


!HTTPSocket class methodsFor: 'proxy settings' stamp: 'yo 4/1/2004 22:02'!
useProxyServerNamed: proxyServerName port: portNum
	"Direct all HTTP requests to the HTTP proxy server with the given name and port number."

	proxyServerName ifNil: [  "clear proxy settings"
		HTTPProxyServer _ nil.
		HTTPProxyPort _ 80.
		^ self].

	proxyServerName class == String
		ifFalse: [self error: 'Server name must be a String or nil'].
	HTTPProxyServer _ proxyServerName.

	HTTPProxyPort _ portNum.
	HTTPProxyPort class == String ifTrue: [HTTPProxyPort _ portNum asNumber].
	HTTPProxyPort ifNil: [HTTPProxyPort _ self defaultPort].! !

