'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6497] on 6 December 2004 at 1:56 pm'!
"Change Set:		SetPlatformPreferencesFix-601-v2-laza
Date:			6 December 2004
Author:			Alexander@Lazarevic.de
Mantis-Bug:		601

A tiny fix so that platform specific preferences actually get set on image startup."!


!SmalltalkImage methodsFor: 'preferences' stamp: 'laza 12/6/2004 13:55'!
setPlatformPreferences
	"Set some platform specific preferences on system startup"
	| platform specs |
	Preferences automaticPlatformSettings ifFalse:[^self].
	platform _ self platformName.
	specs _ 	#(	
					(soundStopWhenDone false)
					(soundQuickStart false)
			).
	platform = 'Win32' ifTrue:[
		specs _ #(	
					(soundStopWhenDone true)
					(soundQuickStart false)
				)].
	platform = 'Mac OS' ifTrue:[
		specs _ #(	
					(soundStopWhenDone false)
					(soundQuickStart true)
				)].
	specs do:[:tuple|
		Preferences setPreference: tuple first toValue: (tuple last == true).
	].
! !

