'From Squeakland.396-Nihongo7.29 of 14 March 2005 [latest update: #31] on 14 March 2005 at 11:53:19 am'!
"Change Set:		TextExtentFix
Date:			14 March 2005
Author:			Yoshiki Ohshima

Make resize of text safe."!


!MultiTextComposer methodsFor: 'as yet unclassified' stamp: 'yo 3/14/2005 10:56'!
composeEachRectangleIn: rectangles

	| myLine lastChar |

	1 to: rectangles size do: [:i | 
		currCharIndex <= theText size ifFalse: [^false].
		myLine _ scanner 
			composeFrom: currCharIndex 
			inRectangle: (rectangles at: i)				
			firstLine: isFirstLine 
			leftSide: i=1 
			rightSide: i=rectangles size.
		myLine last = 0 ifTrue: [^ false].
		lines addLast: myLine.
		presentationLines addLast: scanner getPresentationLine.
		presentation ifNil: [presentation _ scanner getPresentation]
			ifNotNil: [presentation _ presentation, scanner getPresentation].
		actualHeight _ actualHeight max: myLine lineHeight.  "includes font changes"
		currCharIndex _ myLine last + 1.
		lastChar _ theText at: myLine last.
		lastChar = Character cr ifTrue: [^#cr].
		wantsColumnBreaks ifTrue: [
			lastChar = TextComposer characterForColumnBreak ifTrue: [^#columnBreak].
		].
	].
	^false! !


!TextMorph methodsFor: 'geometry' stamp: 'yo 3/14/2005 11:53'!
minimumExtent
	| minExt w |
	textStyle ifNil: [^ 9@16].
	borderWidth ifNil: [^ 9@16].
	text ifNil: [^ 9@16].
	text size = 0 ifTrue: [^ 9@16].
	w _ (textStyle fontArray atPin: (text fontNumberAt: 1)) widthOf: text first.
	minExt _ (w@(textStyle lineGrid+2)) + (borderWidth*2).
	margins ifNil: [^ minExt].
	^ ((0@0 extent: minExt) expandBy: margins) extent! !

